(** Ȥ߹ߴؿ *)

open Interp
open Rtype
open Library 


let debug str = () (* (print_endline str; flush_all ()) *)

(* ξäƤơ*)

let else_Type () = new_ListType (new_Type ()) (newRegVar ())

(*  "+"  *)
let plus = 
  let _plus (regs:Interp.VReg.t list) : scmval = 
    match regs with
      [_;_;ret;rf] ->
	begin 
	  let f (args:Interp.scmval list) = 
	    debug "puls";
	    let numlist = 
	      List.map 
		(function VNum(i,r) -> 
		  begin 
		    VReg.touch r;i 
		  end | _ -> failwith " + : invalid argument")
		args 
	    in 
	    let ans = List.fold_right scm_plus numlist (S_Int(0)) in 
	    VReg.inc ret size_of_num;
	    VNum(ans, ret)
	  in 
	  VReg.inc rf size_of_closure;
	  VBuiltin(f,rf)
	end
    | _ -> failwith "Builtins \"plus\" : Invalid arguments."
  in 
  let brf =  Interp.VReg.newreg Rtype.global_reg in
  VReg.inc brf size_of_closure;
  VBClosure(_plus, brf)

let type_of_plus:rtype_scheme =
  let (r1,r2,r3,rf) = (newRegVar (),newRegVar (),newRegVar (),newRegVar ()) in
  let rs = newRegVar () in
  let e1 = newEffVar () in
  Forall([r1;r2;r3;rf],[rf],[e1],
	 (new_FuncType 
	    ([], new_ListType (new_NumType r1) r2) 
	    (e1,[Reg r1; Reg r2; Reg r3])
	    (new_NumType r3)
	    rf),
	 rs)
	   
(*  "-"  *)
let minus = 
  let _minus (regs:Interp.VReg.t list) : scmval = 
    match regs with
      [_;_;ret;rf] ->
	begin 
	  let f (args:Interp.scmval list) = 
	    debug "minus";
	    let numlist = 
	      List.map 
		(function VNum(i,r) -> 
		  begin 
		    (* print_endline ("touch(-) " ^ (VReg.regname r) ^ " : " ^ (string_of_scmnum i)) ;  *)
		    VReg.touch r;i 
		  end | _ -> failwith " + : invalid argument")
		args 
	    in 
	    let ans =
	      begin 
		match numlist with
		  [hd] -> scm_minus scm_zero hd
		| hd::tl -> scm_minus hd  (List.fold_right scm_plus tl scm_zero) 
		| [] -> scm_zero
	      end
	    in 
	    VReg.inc ret size_of_num;
	    VNum(ans, ret)
	  in 
	  VReg.inc rf size_of_closure;
	  VBuiltin(f,rf)
	end
    | _ -> failwith "Builtins \"minus\" : Invalid arguments."
  in 
  let brf =  Interp.VReg.newreg global_reg in
  VReg.inc brf size_of_closure;
  VBClosure(_minus, brf)

let type_of_minus:rtype_scheme =
  let (r1,r2,r3,rf) = (newRegVar (),newRegVar (),newRegVar (),newRegVar ()) in
  let rs = newRegVar () in
  let e1 = newEffVar () in
  Forall([r1;r2;r3;rf],[rf],[e1],
	 (new_FuncType 
	    ([], new_ListType (new_NumType r1) r2) 
	    (e1,[Reg r1; Reg r2; Reg r3])
	    (new_NumType r3)
	    rf),
	 rs)
	   
(*  "*"  *)
let mul = 
  let _mul (regs:Interp.VReg.t list) : scmval = 
    match regs with
      [_;_;ret;rf] ->
	begin 
	  let f (args:Interp.scmval list) = 
	    debug "mul";
	    let numlist = 
	      List.map 
		(function VNum(i,r) -> 
		  begin 
		    (*print_endline ("touch(+) " ^ (VReg.regname r) ^ " : " ^ (string_of_int i)) ; *)
		    VReg.touch r;i 
		  end | _ -> failwith " * : invalid argument")
		args 
	    in 
	    let ans = List.fold_right scm_mul numlist (S_Int(1)) in 
	    VReg.inc ret  size_of_num;
	    VNum(ans, ret)
	  in 
	  VReg.inc rf size_of_closure;
	  VBuiltin(f,rf)
	end
    | _ -> failwith "Builtins \"mul\" : Invalid arguments."
  in 
  let brf =  Interp.VReg.newreg global_reg in
  VReg.inc brf size_of_closure;
  VBClosure(_mul, brf)

let type_of_mul:rtype_scheme =
  let (r1,r2,r3,rf) = (newRegVar (),newRegVar (),newRegVar (),newRegVar ()) in
  let rs = newRegVar () in
  let e1 = newEffVar () in
  Forall([r1;r2;r3;rf],[rf],[e1],
	 (new_FuncType 
	    ([], new_ListType (new_NumType r1) r2) 
	    (e1,[Reg r1; Reg r2; Reg r3])
	    (new_NumType r3)
	    rf),
	 rs)
	   
(*  "/"  *)
let div = 
  let _div (regs:Interp.VReg.t list) : scmval = 
    match regs with
      [_;_;ret;rf] ->
	begin 
	  let f (args:Interp.scmval list) = 
	    debug "div";
	    let numlist = 
	      List.map 
		(function VNum(i,r) -> 
		  begin 
		    (*  print_endline ("touch(-) " ^ (VReg.regname r) ^ " : " ^ (string_of_int i)) ;  *)
		    (* print_endline (string_of_scmnum i); *)
		    VReg.touch r;i 
		  end | _ -> failwith " / : invalid argument")
		args 
	    in 
	    let ans =
	      begin 
		flush_all ();
		match numlist with
		  [hd] -> scm_div scm_one hd
		| hd::tl -> scm_div hd  (List.fold_right scm_mul tl scm_one) 
		| [] -> scm_one
	      end
	    in 
	    VReg.inc ret  size_of_num;
	    VNum(ans, ret)
	  in 
	  VReg.inc rf size_of_closure;
	  VBuiltin(f,rf)
	end
    | _ -> failwith "Builtins \"div\" : Invalid arguments."
  in 
  let brf =  Interp.VReg.newreg global_reg in
  VReg.inc brf size_of_closure;
  VBClosure(_div, brf)

let type_of_div:rtype_scheme =
  let (r1,r2,r3,rf) = (newRegVar (),newRegVar (),newRegVar (),newRegVar ()) in
  let rs = newRegVar () in
  let e1 = newEffVar () in
  Forall([r1;r2;r3;rf],[rf],[e1],
	 (new_FuncType 
	    ([], new_ListType (new_NumType r1) r2) 
	    (e1,[Reg r1; Reg r2; Reg r3])
	    (new_NumType r3)
	    rf),
	 rs)

(* cons *)
let cons = 
  let _cons (regs:Interp.VReg.t list) : scmval = 
    match regs with
      [ret;rf] ->
	begin 
	  let f (args:Interp.scmval list) = 
	    debug "cons";
	    match args with
	      [car;cdr] ->
		VReg.inc ret size_of_pair;
		VPair({car=car;cdr=cdr},ret)
	    | _ -> failwith "Builtins \"cons\" : Invalid arguments."
	  in 
	  VReg.inc rf size_of_closure;
	  VBuiltin(f,rf)
	end
    | _ -> failwith "Builtins \"cons\" : Invalid arguments."
  in 
  let brf =  Interp.VReg.newreg global_reg in
  VReg.inc brf size_of_closure;
  VBClosure(_cons, brf)

let type_of_cons:rtype_scheme =
  let (r1,rf) = (newRegVar (),newRegVar ()) in
  let rs = newRegVar () in
  let e1 = newEffVar () in
  let (carT,cdrT) = (new_Type (),new_Type ()) in
  Forall([r1;rf],[rf],[e1],
	 (new_FuncType 
	    ([carT;cdrT],else_Type ())
	    (e1,[Reg r1])
	    (new_PairType carT cdrT r1)
	    rf),
	 rs)

(* list *)
let list = 
  let _list (regs:Interp.VReg.t list) : scmval = 
    match regs with
      [ret;rf] ->
	begin 
	  let rec f (args:Interp.scmval list) = 
	    debug "list";
	    match args with
	      [] -> 
		VNill
	    | hd::tl ->
		VReg.inc ret size_of_pair;
		VPair({car=hd;cdr=f tl},ret)

	  in 
	  VReg.inc rf size_of_closure;
	  VBuiltin(f,rf)
	end
    | _ -> failwith "Builtins \"list\" : Invalid arguments."
  in 
  let brf =  Interp.VReg.newreg global_reg in
  VReg.inc brf size_of_closure;
  VBClosure(_list, brf)

let type_of_list:rtype_scheme =
  let (r1,rf) = (newRegVar (),newRegVar ()) in
  let rs = newRegVar () in
  let e1 = newEffVar () in
  let (carT,cdrT) = (new_Type (),new_Type ()) in
  Forall([r1;rf],[rf],[e1],
	 (new_FuncType 
	    ([], new_ListType (new_Type ()) r1) 
	    (e1,[Reg r1])
	    (new_ListType (new_Type ()) r1)
	    rf),
	 rs)


(* car *)
let car = 
  let _car (regs:Interp.VReg.t list) : scmval = 
    match regs with
      [ret;rf] ->
	begin 
	  let f (args:Interp.scmval list) = 
	    debug "car";
	    match args with
	      [VPair({car=car;cdr=cdr},ret)] -> 
		car
	    | _ -> failwith "Builtins \"car\" : Invalid arguments."
	  in 
	  VReg.inc rf size_of_closure;
	  VBuiltin(f,rf)
	end
    | _ -> failwith "Builtins \"car\" : Invalid arguments."
  in 
  let brf =  Interp.VReg.newreg global_reg in
  VReg.inc brf size_of_closure;
  VBClosure(_car, Interp.VReg.newreg global_reg)

let type_of_car:rtype_scheme =
  let (r1,rf) = (newRegVar (),newRegVar ()) in
  let rs = newRegVar () in
  let e1 = newEffVar () in
  let (carT,cdrT) = (new_Type (),new_Type ()) in
  let pairT = new_PairType carT cdrT r1 in
  Forall([r1;rf],[rf],[e1],
	 (new_FuncType 
	    ([pairT],else_Type ())
	    (e1,[Reg r1])
	    carT
	    rf),
	 rs)

(* cdr *)
let cdr = 
  let _cdr (regs:Interp.VReg.t list) : scmval = 
    match regs with
      [ret;rf] ->
	begin 
	  let f (args:Interp.scmval list) = 
	    debug "cdr";
	    match args with
	      [VPair({car=car;cdr=cdr},ret)] -> 
		cdr
	    | _ -> failwith "Builtins \"cdr\" : Invalid arguments."
	  in 
	  VReg.inc rf size_of_closure;
	  VBuiltin(f,rf)
	end
    | _ -> failwith "Builtins \"cdr\" : Invalid arguments."
  in 
  let brf =  Interp.VReg.newreg global_reg in
  VReg.inc brf size_of_closure;
  VBClosure(_cdr, brf)

let type_of_cdr:rtype_scheme =
  let (r1,rf) = (newRegVar (),newRegVar ()) in
  let rs = newRegVar () in
  let e1 = newEffVar () in
  let (carT,cdrT) = (new_Type (),new_Type ()) in
  let pairT = new_PairType carT cdrT r1 in
  Forall([r1;rf],[rf],[e1],
	 (new_FuncType 
	    ([pairT],else_Type ())
	    (e1,[Reg r1])
	    cdrT
	    rf),
	 rs)

(* set-car *)
let setcar = 
  let _setcar (regs:Interp.VReg.t list) : scmval = 
    match regs with
      [ret;rf] ->
	begin 
	  let f (args:Interp.scmval list) = 
	    debug "set-car!";
	    match args with
	      [VPair(cell,ret);obj] -> 
		cell.car <- obj;
		VUndef
	    | _ -> failwith "Builtins \"set-car!\" : Invalid arguments."
	  in 
	  VReg.inc rf size_of_closure;
	  VBuiltin(f,rf)
	end
    | _ -> failwith "Builtins \"set-car!\" : Invalid arguments."
  in 
  let brf =  Interp.VReg.newreg global_reg in
  VReg.inc brf size_of_closure;
  VBClosure(_setcar, brf)

let type_of_setcar:rtype_scheme =
  let (r1,rf) = (newRegVar (),newRegVar ()) in
  let rs = newRegVar () in
  let e1 = newEffVar () in
  let (carT,cdrT,retT) = (new_Type (),new_Type (),new_Type ()) in
  let pairT = new_PairType carT cdrT r1 in
  Forall([r1;rf],[rf],[e1],
	 (new_FuncType 
	    ([pairT; carT],else_Type ())
	    (e1,[Reg r1])
	    retT
	    rf),
	 rs)
(* set-cdr *)
let setcdr = 
  let _setcdr (regs:Interp.VReg.t list) : scmval = 
    match regs with
      [ret;rf] ->
	begin 
	  let f (args:Interp.scmval list) = 
	    debug "set-cdr!";
	    match args with
	      [VPair(cell,ret);obj] -> 
		cell.cdr <- obj;
		VUndef
	    | _ -> failwith "Builtins \"set-cdr!\" : Invalid arguments."
	  in 
	  VReg.inc rf size_of_closure;
	  VBuiltin(f,rf)
	end
    | _ -> failwith "Builtins \"set-cdr!\" : Invalid arguments."
  in 
  let brf =  Interp.VReg.newreg global_reg in
  VReg.inc brf size_of_closure;
  VBClosure(_setcdr, brf)

let type_of_setcdr:rtype_scheme =
  let (r1,rf) = (newRegVar (),newRegVar ()) in
  let rs = newRegVar () in
  let e1 = newEffVar () in
  let (carT,cdrT,retT) = (new_Type (),new_Type (),new_Type ()) in
  let pairT = new_PairType carT cdrT r1 in
  Forall([r1;rf],[rf],[e1],
	 (new_FuncType 
	    ([pairT; cdrT],else_Type ())
	    (e1,[Reg r1])
	    retT
	    rf),
	 rs)


(* write *)
let write = 
  let _write (regs:Interp.VReg.t list) : scmval = 
    match regs with
      [ _;rf ] ->
	begin 
	  let f (args:Interp.scmval list) = 
	    debug "write";
	    match args with
	      [v] -> 
		print_string (string_of_scmval v); VNill
	    | _ -> failwith "Builtins \"write\" : Invalid arguments."
	  in 
	  VReg.inc rf size_of_closure;
	  VBuiltin(f,rf)
	end
    | _ -> failwith "Builtins \"write\" : Invalid arguments."
  in 
  let brf =  Interp.VReg.newreg global_reg in
  VReg.inc brf size_of_closure;
  VBClosure(_write, brf)

let type_of_write:rtype_scheme =
  let (r1,rf) = (newRegVar (),newRegVar ()) in
  let rs = newRegVar () in
  let (e1,e2) = (newEffVar (),newEffVar ()) in
  Forall([r1;rf],[rf],[e1;e2],
	 (new_FuncType 
	    ([new_AllType r1 r1 r1 r1 r1 r1 (e1,[])],else_Type ())
	    (e2,[Reg r1])
	    (else_Type ())
	    rf),
	 rs)
(* display *)
let scm_display = 
  let rec string_of_v_d v = 
    match v with
      VNum(i,_) -> string_of_scmnum i
    | VBool(true) -> "#t" 
    | VBool(false) -> "#f" 
    | VChar(c,_) ->  let s = " " in s.[0]<- c; s
    | VSymbol(sym,r) ->  sym 
    | VString(str,r) ->  str 
    | VClosure _ -> "*procedure*"
    | VRClosure _ -> "*procedure*"
    | VPair(v,_) -> "(" ^ (string_of_v_d v.car) ^ " . " ^ (string_of_v_d v.cdr) ^ ")"
    | VNill -> "'()"
    | VVector (v,_) -> "#(" ^ (Array.fold_right (^) (Array.map string_of_v_d v) "") ^ ")"
    | VUndef -> "*undef*"
    | Vinport _ -> "*inport*"
    | Voutport _ -> "*outport*"
    | VBClosure _ -> "*procedure*"
    | VBuiltin _ -> "*procedure*"
  in 
  let _scm_display (regs:Interp.VReg.t list) : scmval = 
    match regs with
      [ _;rf ] ->
	begin 
	  let f (args:Interp.scmval list) = 
	    debug "display";
	    match args with
	      [v;Voutport(op,r)] -> 
		output_string op (string_of_v_d v);
		VUndef
	    | [v] -> 
		print_string (string_of_v_d v);
		VUndef
	    | _ -> failwith "Builtins \"display\" : Invalid arguments."
	  in 
	  VReg.inc rf size_of_closure;
	  VBuiltin(f,rf)
	end
    | _ -> failwith "Builtins \"display\" : Invalid arguments."
  in 
  let brf =  Interp.VReg.newreg global_reg in
  VReg.inc brf size_of_closure;
  VBClosure(_scm_display, brf)

let type_of_scm_display:rtype_scheme =
  let (r1,rf) = (newRegVar (),newRegVar ()) in
  let rs = newRegVar () in
  let (e1,e2) = (newEffVar (),newEffVar ()) in
  Forall([r1;rf],[rf],[e1;e2],
	 (new_FuncType 
	    ([new_AllType r1 r1 r1 r1 r1 r1 (e1,[])],else_Type ())
	    (e2,[Reg r1])
	    (else_Type ())
	    rf),
	 rs)

(* = *)
let math_equal = 
  let _math_equal (regs:Interp.VReg.t list) : scmval = 
    match regs with
      [_;_;rf] ->
	begin 
	  let f (args:Interp.scmval list) = 
	    debug "=";
	    match args with
	      [VNum(i1,_);VNum(i2,_)] -> 
		debug (" (= " ^ (string_of_scmnum i1) ^ " " ^ (string_of_scmnum i2) ^ ") -> " 
		       ^ (string_of_scmval  (VBool(scm_eq i1  i2))));
		VBool(scm_eq i1  i2)
	    | _ -> failwith "Builtins \"=\" : Invalid arguments."
	  in 
	  VReg.inc rf size_of_closure;
	  VBuiltin(f,rf)
	end
    | _ -> failwith "Builtins \"=\" : Invalid arguments."
  in 
  let brf =  Interp.VReg.newreg global_reg in
  VReg.inc brf size_of_closure;
  VBClosure(_math_equal, brf)

let type_of_math_equal:rtype_scheme =
  let (r1,r2,rf) = (newRegVar (),newRegVar (),newRegVar ()) in
  let rs = newRegVar () in
  let e1 = newEffVar () in
  Forall([r1;r2;rf],[rf],[e1],
	 (new_FuncType 
	    ([new_NumType r1;new_NumType r2],else_Type ())
	    (e1,[Reg r1; Reg r2])
	    (new_BoolType ())
	    rf),
	 rs)


(* eq? *)
let eq = 
  let _eq (regs:Interp.VReg.t list) : scmval = 
    match regs with
      [rf] ->
	begin 
	  let f (args:Interp.scmval list) = 
	    debug "eq?";
	    match args with
	      [a;b] -> 
		VBool(a = b)
	    | _ -> failwith "Builtins \"eq?\" : Invalid arguments."
	  in 
	  VReg.inc rf size_of_closure;
	  VBuiltin(f,rf)
	end
    | _ -> failwith "Builtins \"eq?\" : Invalid arguments."
  in 
  let brf =  Interp.VReg.newreg global_reg in
  VReg.inc brf size_of_closure;
  VBClosure(_eq, brf)

let type_of_eq:rtype_scheme =
  let (rf) = (newRegVar ()) in
  let rs = newRegVar () in
  let e1 = newEffVar () in
  Forall([rf],[rf],[e1],
	 (new_FuncType 
	    ([new_Type ();new_Type ()],else_Type ())
	    (e1,[])
	    (new_BoolType ())
	    rf),
	 rs)



(* < *)
let less_than = 
  let _less_than (regs:Interp.VReg.t list) : scmval = 
    match regs with
      [_;_;rf] ->
	begin 
	  let f (args:Interp.scmval list) = 
	    debug "<";
	    match args with
	      [VNum(i1,_);VNum(i2,_)] -> 
		VBool(scm_lt i1  i2)
	    | _ -> failwith "Builtins \"<\" : Invalid arguments."
	  in 
	  VReg.inc rf size_of_closure;
	  VBuiltin(f,rf)
	end
    | _ -> failwith "Builtins \"<\" : Invalid arguments."
  in 
  let brf =  Interp.VReg.newreg global_reg in
  VReg.inc brf size_of_closure;
  VBClosure(_less_than, brf)

let type_of_less_than:rtype_scheme =
  let (r1,r2,rf) = (newRegVar (),newRegVar (),newRegVar ()) in
  let rs = newRegVar () in
  let e1 = newEffVar () in
  Forall([r1;r2;rf],[rf],[e1],
	 (new_FuncType 
	    ([new_NumType r1;new_NumType r2],else_Type ())
	    (e1,[Reg r1; Reg r2])
	    (new_BoolType ())
	    rf),
	 rs)

(* <= *)
let less_eq = 
  let _less_eq (regs:Interp.VReg.t list) : scmval = 
    match regs with
      [_;_;rf] ->
	begin 
	  let f (args:Interp.scmval list) = 
	    debug ">";
	    match args with
	      [VNum(i1,_);VNum(i2,_)] -> 
		VBool(scm_le i1 i2)
	    | _ -> failwith "Builtins \"<\" : Invalid arguments."
	  in 
	  VReg.inc rf size_of_closure;
	  VBuiltin(f,rf)
	end
    | _ -> failwith "Builtins \"<\" : Invalid arguments."
  in 
  let brf =  Interp.VReg.newreg global_reg in
  VReg.inc brf size_of_closure;
  VBClosure(_less_eq, brf)

let type_of_less_eq:rtype_scheme =
  let (r1,r2,rf) = (newRegVar (),newRegVar (),newRegVar ()) in
  let rs = newRegVar () in
  let e1 = newEffVar () in
  Forall([r1;r2;rf],[rf],[e1],
	 (new_FuncType 
	    ([new_NumType r1;new_NumType r2],else_Type ())
	    (e1,[Reg r1; Reg r2])
	    (new_BoolType ())
	    rf),
	 rs)

(* > *)
let greater_than = 
  let _greater_than (regs:Interp.VReg.t list) : scmval = 
    match regs with
      [_;_;rf] ->
	begin 
	  let f (args:Interp.scmval list) = 
	    debug ">";
	    match args with
	      [VNum(i1,_);VNum(i2,_)] -> 
		VBool(scm_gt i1  i2)
	    | _ -> failwith "Builtins \">\" : Invalid arguments."
	  in 
	  VReg.inc rf size_of_closure;
	  VBuiltin(f,rf)
	end
    | _ -> failwith "Builtins \">\" : Invalid arguments."
  in 
  let brf =  Interp.VReg.newreg global_reg in
  VReg.inc brf size_of_closure;
  VBClosure(_greater_than, brf)

let type_of_greater_than:rtype_scheme =
  let (r1,r2,rf) = (newRegVar (),newRegVar (),newRegVar ()) in
  let rs = newRegVar () in
  let e1 = newEffVar () in
  Forall([r1;r2;rf],[rf],[e1],
	 (new_FuncType 
	    ([new_NumType r1;new_NumType r2],else_Type ())
	    (e1,[Reg r1; Reg r2])
	    (new_BoolType ())
	    rf),
	 rs)
(* >= *)
let greater_eq = 
  let _greater_eq (regs:Interp.VReg.t list) : scmval = 
    match regs with
      [_;_;rf] ->
	begin 
	  let f (args:Interp.scmval list) = 
	    debug ">=";
	    match args with
	      [VNum(i1,_);VNum(i2,_)] -> 
		VBool(scm_ge i1  i2)
	    | _ -> failwith "Builtins \">\" : Invalid arguments."
	  in 
	  VReg.inc rf size_of_closure;
	  VBuiltin(f,rf)
	end
    | _ -> failwith "Builtins \">\" : Invalid arguments."
  in 
  let brf =  Interp.VReg.newreg global_reg in
  VReg.inc brf size_of_closure;
  VBClosure(_greater_eq, brf)

let type_of_greater_eq:rtype_scheme =
  let (r1,r2,rf) = (newRegVar (),newRegVar (),newRegVar ()) in
  let rs = newRegVar () in
  let e1 = newEffVar () in
  Forall([r1;r2;rf],[rf],[e1],
	 (new_FuncType 
	    ([new_NumType r1;new_NumType r2],else_Type ())
	    (e1,[Reg r1; Reg r2])
	    (new_BoolType ())
	    rf),
	 rs)



(* pair? *)
let pair = 
  let _pair (regs:Interp.VReg.t list) : scmval = 
    match regs with
      [_;rf] ->
	begin 
	  let f (args:Interp.scmval list) = 
	    debug "pair?";
	    match args with
	      [VPair(_,r)] -> 
		VReg.touch r;
		VBool(true)
	    | [_] -> VBool(false)
	    | _ -> failwith "Builtins \"pair?\" : Invalid arguments."
	  in 
	  VReg.inc rf size_of_closure;
	  VBuiltin(f,rf)
	end
    | _ -> failwith "Builtins \"pair?\" : Invalid arguments."
  in 
  let brf =  Interp.VReg.newreg global_reg in
  VReg.inc brf size_of_closure;
  VBClosure(_pair, brf)

let type_of_pair:rtype_scheme =
  let (r1,rf) = (newRegVar (),newRegVar ()) in
  let rs = newRegVar () in
  let e1 = newEffVar () in
  Forall([r1;rf],[rf],[e1],
	 (new_FuncType 
	    ([new_PairType (new_Type ()) (new_Type ()) r1],else_Type ())
	    (e1,[Reg r1])
	    (new_BoolType ())
	    rf),
	 rs)
(* null? *)
let qnull = 
  let _qnull (regs:Interp.VReg.t list) : scmval = 
    match regs with
      [rf] ->
	begin 
	  let f (args:Interp.scmval list) = 
	    debug "null?";
	    match args with
	      [VNill] -> 
		VBool(true)
	    | [_] -> VBool(false)
	    | _ -> failwith "Builtins \"pair?\" : Invalid arguments."
	  in 
	  VReg.inc rf size_of_closure;
	  VBuiltin(f,rf)
	end
    | _ -> failwith "Builtins \"pair?\" : Invalid arguments."
  in 
  let brf =  Interp.VReg.newreg global_reg in
  VReg.inc brf size_of_closure;
  VBClosure(_qnull, brf)

let type_of_qnull:rtype_scheme =
  let rf = newRegVar () in
  let rs = newRegVar () in
  let e1 = newEffVar () in
  Forall([rf],[rf],[e1],
	 (new_FuncType 
	    ([new_Type ()],else_Type ())
	    (e1,[])
	    (new_BoolType ())
	    rf),
	 rs)


(* not *)
let scm_not = 
  let _scm_not (regs:Interp.VReg.t list) : scmval = 
    match regs with
      [_;rf] ->
	begin 
	  let f (args:Interp.scmval list) = 
	    debug "not";
	    match args with
	      [VBool(false)] -> 
		VBool(true)
	    | [_] -> VBool(false)
	    | _ -> failwith "Builtins \"not\" : Invalid arguments."
	  in 
	  VReg.inc rf size_of_closure;
	  VBuiltin(f,rf)
	end
    | _ -> failwith "Builtins \"not\" : Invalid arguments."
  in 
  let brf =  Interp.VReg.newreg global_reg in
  VReg.inc brf size_of_closure;
  VBClosure(_scm_not, brf)

let type_of_scm_not:rtype_scheme =
  let (r1,rf) = (newRegVar (),newRegVar ()) in
  let rs = newRegVar () in
  let e1 = newEffVar () in
  Forall([r1;rf],[rf],[e1],
	 (new_FuncType 
	    ([new_Type ()],else_Type ())
	    (e1,[Reg r1])
	    (new_BoolType ())
	    rf),
	 rs)
(* file-exist? *)
let scm_file_exists = 
  let _scm_file_exists (regs:Interp.VReg.t list) : scmval = 
    match regs with
      [_;rf] ->
	begin 
	  let f (args:Interp.scmval list) = 
	    match args with
	      [VString(fname,r)] -> 
		VBool(Sys.file_exists fname)
	    | _ -> failwith "Builtins \"exists\" : Invalid arguments."
	  in 
	  VReg.inc rf size_of_closure;
	  VBuiltin(f,rf)
	end
    | _ -> failwith "Builtins \"exists\" : Invalid arguments."
  in 
  let brf =  Interp.VReg.newreg global_reg in
  VReg.inc brf size_of_closure;
  VBClosure(_scm_file_exists, brf)

let type_of_scm_file_exists:rtype_scheme =
  let (r1,rf) = (newRegVar (),newRegVar ()) in
  let rs = newRegVar () in
  let e1 = newEffVar () in
  Forall([r1;rf],[rf],[e1],
	 (new_FuncType 
	    ([new_StringType r1],else_Type ())
	    (e1,[Reg r1])
	    (new_BoolType ())
	    rf),
	 rs)
(* delete-file *)
let scm_delete_file = 
  let _scm_delete_file (regs:Interp.VReg.t list) : scmval = 
    match regs with
      [_;rf] ->
	begin 
	  let f (args:Interp.scmval list) = 
	    debug "delete-file";
	    match args with
	      [VString(fname,r)] -> 
		Sys.remove fname;
		VUndef
	    | _ -> failwith "Builtins \"delete_file\" : Invalid arguments."
	  in 
	  VReg.inc rf size_of_closure;
	  VBuiltin(f,rf)
	end
    | _ -> failwith "Builtins \"delete_file\" : Invalid arguments."
  in 
  let brf =  Interp.VReg.newreg global_reg in
  VReg.inc brf size_of_closure;
  VBClosure(_scm_delete_file, brf)

let type_of_scm_delete_file:rtype_scheme =
  let (r1,rf) = (newRegVar (),newRegVar ()) in
  let rs = newRegVar () in
  let e1 = newEffVar () in
  Forall([r1;rf],[rf],[e1],
	 (new_FuncType 
	    ([new_StringType r1],else_Type ())
	    (e1,[Reg r1])
	    (new_Type ())
	    rf),
	 rs)
(* cos *)
let built_cos = 
  let _built_cos (regs:Interp.VReg.t list) : scmval = 
    match regs with
      [r1;r2;rf] ->
	begin 
	  let f (args:Interp.scmval list) = 
	    debug "cos";
	    match args with
	      [VNum(n,r)] -> 
		VReg.inc r2 size_of_num;
		VNum(scm_cos n,r2)
	    | _ -> failwith "Builtins \"cos\" : Invalid arguments."
	  in 
	  VReg.inc rf size_of_closure;
	  VBuiltin(f,rf)
	end
    | _ -> failwith "Builtins \"cos\" : Invalid arguments."
  in 
  let brf =  Interp.VReg.newreg global_reg in
  VReg.inc brf size_of_closure;
  VBClosure(_built_cos, brf)
(* sin *)
let built_sin = 
  let _built_sin (regs:Interp.VReg.t list) : scmval = 
    match regs with
      [r1;r2;rf] ->
	begin 
	  let f (args:Interp.scmval list) = 
	    debug "sin";
	    match args with
	      [VNum(n,r)] -> 
		VReg.inc r2 size_of_num;
		VNum(scm_sin n,r2)
	    | _ -> failwith "Builtins \"sin\" : Invalid arguments."
	  in 
	  VReg.inc rf size_of_closure;
	  VBuiltin(f,rf)
	end
    | _ -> failwith "Builtins \"sin\" : Invalid arguments."
  in 
  let brf =  Interp.VReg.newreg global_reg in
  VReg.inc brf size_of_closure;
  VBClosure(_built_sin, brf)
(* tan *)
let built_tan = 
  let _built_tan (regs:Interp.VReg.t list) : scmval = 
    match regs with
      [r1;r2;rf] ->
	begin 
	  let f (args:Interp.scmval list) = 
	    debug "tan";
	    match args with
	      [VNum(n,r)] -> 
		VReg.inc r2 size_of_num;
		VNum(scm_tan n,r2)
	    | _ -> failwith "Builtins \"tan\" : Invalid arguments."
	  in 
	  VReg.inc rf size_of_closure;
	  VBuiltin(f,rf)
	end
    | _ -> failwith "Builtins \"tan\" : Invalid arguments."
  in 
  let brf =  Interp.VReg.newreg global_reg in
  VReg.inc brf size_of_closure;
  VBClosure(_built_tan, brf)
(* atan *)
let built_atan = 
  let _built_atan (regs:Interp.VReg.t list) : scmval = 
    match regs with
      [r1;r2;rf] ->
	begin 
	  let f (args:Interp.scmval list) = 
	    debug "atan";
	    match args with
	      [VNum(n,r)] -> 
		VReg.inc r2 size_of_num;
		VNum(scm_atan n,r2)
	    | _ -> failwith "Builtins \"atan\" : Invalid arguments."
	  in 
	  VReg.inc rf size_of_closure;
	  VBuiltin(f,rf)
	end
    | _ -> failwith "Builtins \"atan\" : Invalid arguments."
  in 
  let brf =  Interp.VReg.newreg global_reg in
  VReg.inc brf size_of_closure;
  VBClosure(_built_atan, brf)
(* sqrt *)
let built_sqrt = 
  let _built_sqrt (regs:Interp.VReg.t list) : scmval = 
    match regs with
      [r1;r2;rf] ->
	begin 
	  let f (args:Interp.scmval list) = 
	    debug "sqrt";
	    match args with
	      [VNum(n,r)] -> 
		VReg.inc r2 size_of_num;
		VNum(scm_sqrt n,r2)
	    | _ -> failwith "Builtins \"sqrt\" : Invalid arguments."
	  in 
	  VReg.inc rf size_of_closure;
	  VBuiltin(f,rf)
	end
    | _ -> failwith "Builtins \"sqrt\" : Invalid arguments."
  in 
  let brf =  Interp.VReg.newreg global_reg in
  VReg.inc brf size_of_closure;
  VBClosure(_built_sqrt, brf)
(* truncate *)
let built_truncate = 
  let _built_truncate (regs:Interp.VReg.t list) : scmval = 
    match regs with
      [r1;r2;rf] ->
	begin 
	  let f (args:Interp.scmval list) = 
	    debug "truncate";
	    match args with
	      [VNum(n,r)] -> 
		VReg.inc r2 size_of_num;
		VNum(scm_truncate n,r2)
	    | _ -> failwith "Builtins \"truncate\" : Invalid arguments."
	  in 
	  VReg.inc rf size_of_closure;
	  VBuiltin(f,rf)
	end
    | _ -> failwith "Builtins \"truncate\" : Invalid arguments."
  in 
  let brf =  Interp.VReg.newreg global_reg in
  VReg.inc brf size_of_closure;
  VBClosure(_built_truncate, brf)
(* floor *)
let built_floor = 
  let _built_floor (regs:Interp.VReg.t list) : scmval = 
    match regs with
      [r1;r2;rf] ->
	begin 
	  let f (args:Interp.scmval list) = 
	    debug "floor";
	    match args with
	      [VNum(n,r)] -> 
		VReg.inc r2 size_of_num;
		VNum(scm_floor n,r2)
	    | _ -> failwith "Builtins \"floor\" : Invalid arguments."
	  in 
	  VReg.inc rf size_of_closure;
	  VBuiltin(f,rf)
	end
    | _ -> failwith "Builtins \"floor\" : Invalid arguments."
  in 
  let brf =  Interp.VReg.newreg global_reg in
  VReg.inc brf size_of_closure;
  VBClosure(_built_floor, brf)
(* abs *)
let built_abs = 
  let _built_abs (regs:Interp.VReg.t list) : scmval = 
    match regs with
      [r1;r2;rf] ->
	begin 
	  let f (args:Interp.scmval list) = 
	    debug "abs";
	    match args with
	      [VNum(n,r)] -> 
		VReg.inc r2 size_of_num;
		VNum(scm_abs n,r2)
	    | _ -> failwith "Builtins \"abs\" : Invalid arguments."
	  in 
	  VReg.inc rf size_of_closure;
	  VBuiltin(f,rf)
	end
    | _ -> failwith "Builtins \"abs\" : Invalid arguments."
  in 
  let brf =  Interp.VReg.newreg global_reg in
  VReg.inc brf size_of_closure;
  VBClosure(_built_abs, brf)

let create_type_of_num_to_num () =
  let type_of_built_float_to_float:rtype_scheme =
    let (r1,r2,rf) = (newRegVar (),newRegVar (),newRegVar ()) in
    let rs = newRegVar () in
    let e1 = newEffVar () in
    Forall([r1;r2;rf],[rf],[e1],
	   (new_FuncType 
	      ([new_NumType r1],else_Type ())
	      (e1,[Reg r1;Reg r2])
	      (new_NumType r2)
	      rf),
	   rs)
  in type_of_built_float_to_float

(* open-input-file *)
let scm_open_in = 
  let _scm_open_in (regs:Interp.VReg.t list) : scmval = 
    match regs with
      [rs;rp;rf] ->
	begin 
	  let f (args:Interp.scmval list) = 
	    debug "open-input-file";
	    match args with
	      [VString(fname,r)] -> 
		VReg.inc rp size_of_port;
		let inc = open_in fname in 
		Vinport(Lexing.from_channel inc,inc,rp)
	    | _ -> failwith "Builtins \"open-input-file\" : Invalid arguments."
	  in 
	  VReg.inc rf size_of_closure;
	  VBuiltin(f,rf)
	end
    | _ -> failwith "Builtins \"open-input-file\" : Invalid arguments."
  in 
  let brf =  Interp.VReg.newreg global_reg in
  VReg.inc brf size_of_closure;
  VBClosure(_scm_open_in, brf)

let type_of_scm_open_in:rtype_scheme =
  let (r1,r2,rf) = (newRegVar (),newRegVar (),newRegVar ()) in
  let rs = newRegVar () in
  let e1 = newEffVar () in
  Forall([r1;r2;rf],[rf],[e1],
	 (new_FuncType 
	    ([new_StringType r1],else_Type ())
	    (e1,[Reg r1;Reg r2])
	    (new_PortType r2)
	    rf),
	 rs)
(* close-input-file *)
let scm_close_in = 
  let _scm_close_in (regs:Interp.VReg.t list) : scmval = 
    match regs with
      [rs;rf] ->
	begin 
	  let f (args:Interp.scmval list) = 
	    debug "close-input-file";
	    match args with
	      [Vinport(inp,inc,r)] -> 
		close_in inc;
		VUndef
	    | _ -> failwith "Builtins \"close_in\" : Invalid arguments."
	  in 
	  VReg.inc rf size_of_closure;
	  VBuiltin(f,rf)
	end
    | _ -> failwith "Builtins \"close_in\" : Invalid arguments."
  in 
  let brf =  Interp.VReg.newreg global_reg in
  VReg.inc brf size_of_closure;
  VBClosure(_scm_close_in, brf)

let type_of_scm_close_in:rtype_scheme =
  let (r1,rf) = (newRegVar (),newRegVar ()) in
  let rs = newRegVar () in
  let e1 = newEffVar () in
  Forall([r1;rf],[rf],[e1],
	 (new_FuncType 
	    ([new_PortType r1],else_Type ())
	    (e1,[Reg r1])
	    (new_Type ())
	    rf),
	 rs)
(* open-output-file *)
let scm_open_out = 
  let _scm_open_out (regs:Interp.VReg.t list) : scmval = 
    match regs with
      [rs;rp;rf] ->
	begin 
	  let f (args:Interp.scmval list) = 
	    debug "open-output-file";
	    match args with
	      [VString(fname,r)] -> 
		VReg.inc rp size_of_port;
		Voutport(open_out fname,rp)
	    | _ -> failwith "Builtins \"open_out\" : Invalid arguments."
	  in 
	  VBuiltin(f,rf)
	end
    | _ -> failwith "Builtins \"open_out\" : Invalid arguments."
  in 
  let brf =  Interp.VReg.newreg global_reg in
  VReg.inc brf size_of_closure;
  VBClosure(_scm_open_out, brf)

let type_of_scm_open_out:rtype_scheme =
  let (r1,r2,rf) = (newRegVar (),newRegVar (),newRegVar ()) in
  let rs = newRegVar () in
  let e1 = newEffVar () in
  Forall([r1;r2;rf],[rf],[e1],
	 (new_FuncType 
	    ([new_StringType r1],else_Type ())
	    (e1,[Reg r1;Reg r2])
	    (new_PortType r2)
	    rf),
	 rs)

(* read *)
let scm_read = 
  let _scm_read (regs:Interp.VReg.t list) : scmval = 
    match regs with
      [rs;rp;rf] ->
	begin 
	  let f (args:Interp.scmval list) = 
	    debug "read";
	    match args with
	      [Vinport(in_b,inc,r)] -> 
		Interp.read_set_reg rp;
		debug ("regname = " ^ Interp.VReg.regname rp);
		let a = Read_parser.datum  Read_lexer.token in_b in
		print_endline (string_of_scmval a);
		a
	    | _ -> failwith "Builtins \"read\" : Invalid arguments."
	  in 
	  VReg.inc rf size_of_closure;
	  VBuiltin(f,rf)
	end
    | _ -> failwith "Builtins \"read\" : Invalid arguments."
  in 
  let brf =  Interp.VReg.newreg global_reg in
  VReg.inc brf size_of_closure;
  VBClosure(_scm_read, brf)

let type_of_scm_read:rtype_scheme =
  let (r1,r2,rf) = (newRegVar (),newRegVar (),newRegVar ()) in
  let rs = newRegVar () in
  let e1 = newEffVar () in
  Forall([r1;r2;rf],[rf],[e1],
	 (new_FuncType 
	    ([new_StringType r1],else_Type ())
	    (e1,[Reg r1;Reg r2])
	    (new_DatumType r2)
	    rf),
	 rs)


(* close-output-file *)
let scm_close_out = 
  let _scm_close_out (regs:Interp.VReg.t list) : scmval = 
    match regs with
      [rs;rf] ->
	begin 
	  let f (args:Interp.scmval list) = 
	    debug "close-output-file";
	    match args with
	      [Voutport(outp,r)] -> 
		close_out outp;
		VUndef
	    | _ -> failwith "Builtins \"close_out\" : Invalid arguments."
	  in 
	  VReg.inc rf size_of_closure;
	  VBuiltin(f,rf)
	end
    | _ -> failwith "Builtins \"close_out\" : Invalid arguments."
  in 
  let brf =  Interp.VReg.newreg global_reg in
  VReg.inc brf size_of_closure;
  VBClosure(_scm_close_out, brf)

let type_of_scm_close_out:rtype_scheme =
  let (r1,rf) = (newRegVar (),newRegVar ()) in
  let rs = newRegVar () in
  let e1 = newEffVar () in
  Forall([r1;rf],[rf],[e1],
	 (new_FuncType 
	    ([new_PortType r1],else_Type ())
	    (e1,[Reg r1])
	    (new_Type ())
	    rf),
	 rs)

(* make-vector *)
let makevec = 
  let _makevec (regs:Interp.VReg.t list) : scmval = 
    match regs with
      [r1;r2;rf] ->
	begin 
	  let f (args:Interp.scmval list) = 
	    debug "make-vector";
	    match args with
	      [VNum(S_Int(i),reg);v] -> 
		VReg.inc r2 (size_of_vector i);
		VVector(Array.make i v, r2)
	    | [VNum(S_Int(i),reg)] -> 
		VReg.inc r2 (size_of_vector i);
		VVector(Array.make i VUndef, r2)
	    | [v] ->
		failwith ("Builtins \"make-vector\" : Invalid arguments."
			  ^ (string_of_scmval v))
	    | _ -> failwith "Builtins \"make-vector\" : Invalid arguments."
	  in 
	  VReg.inc rf size_of_closure;
	  VBuiltin(f,rf)
	end
    | _ -> failwith "Builtins \"make-vector\" : Invalid region arguments."
  in 
  let brf =  Interp.VReg.newreg global_reg in
  VReg.inc brf size_of_closure;
  VBClosure(_makevec, brf)

let type_of_makevec:rtype_scheme =
  let (r1,r2,rf) = (newRegVar (),newRegVar (),newRegVar ()) in
  let rs = newRegVar () in
  let e1 = newEffVar () in
  let t1 = new_Type () in
  Forall([r1;r2;rf],[rf],[e1],
	 (new_FuncType 
	    ([new_NumType r1;t1],else_Type ())
	    (e1,[Reg r1;Reg r2])
	    (new_VectorType t1 r2)
	    rf),
	 rs)
(* vector-set! *)
let vecset = 
  let _vecset (regs:Interp.VReg.t list) : scmval = 
    match regs with
      [r1;r2;rf] ->
	begin 
	  let f (args:Interp.scmval list) = 
	    debug "vector-set!";
	    match args with
	      [VVector(ary,r1); VNum(S_Int(k),r2); v] -> 
		ary.(k) <- v;
		VUndef
	    | _ -> failwith "Builtins \"vector-set!\" : Invalid arguments."
	  in 
	  VReg.inc rf size_of_closure;
	  VBuiltin(f,rf)
	end
    | _ -> failwith "Builtins \"vector-set!\" : Invalid region arguments."
  in 
  let brf =  Interp.VReg.newreg global_reg in
  VReg.inc brf size_of_closure;
  VBClosure(_vecset, brf)

let type_of_vecset:rtype_scheme =
  let (r1,r2,rf) = (newRegVar (),newRegVar (),newRegVar ()) in
  let rs = newRegVar () in
  let e1 = newEffVar () in
  let t1 = new_Type () in
  Forall([r1;r2;rf],[rf],[e1],
	 (new_FuncType 
	    ([(new_VectorType t1 r1);(new_NumType r2);t1],else_Type ())
	    (e1,[Reg r1;Reg r2])
	    (new_Type ())
	    rf),
	 rs)
(* vector-ref *)
let vecref = 
  let _vecref (regs:Interp.VReg.t list) : scmval = 
    match regs with
      [r1;r2;rf] ->
	begin 
	  let f (args:Interp.scmval list) = 
	    debug "vector-ref";
	    match args with
	      [VVector(ary,r1); VNum(S_Int(k),r2)] -> 
		debug ("vector-ref : " ^ (string_of_int (Array.length ary)) ^ " of " ^ (string_of_int k));
		ary.(k)
	    | _ -> failwith "Builtins \"vector-ref\" : Invalid arguments."
	  in 
	  VReg.inc rf size_of_closure;
	  VBuiltin(f,rf)
	end
    | _ -> failwith "Builtins \"vector-ref\" : Invalid region arguments."
  in 
  let brf =  Interp.VReg.newreg global_reg in
  VReg.inc brf size_of_closure;
  VBClosure(_vecref, brf)

let type_of_vecref:rtype_scheme =
  let (r1,r2,rf) = (newRegVar (),newRegVar (),newRegVar ()) in
  let rs = newRegVar () in
  let e1 = newEffVar () in
  let t1 = new_Type () in
  Forall([r1;r2;rf],[rf],[e1],
	 (new_FuncType 
	    ([(new_VectorType t1 r1);(new_NumType r2)],else_Type ())
	    (e1,[Reg r1;Reg r2])
	    t1
	    rf),
	 rs)


(* mark *)
let mark = 
  let _mark (regs:Interp.VReg.t list) : scmval = 
    match regs with
      [rf] ->
	begin 
	  let f (args:Interp.scmval list) = 
	    match args with
	      [] -> 
		Interp.VReg.mark ();
		VUndef
	    | _ -> failwith "Builtins \"mark\" : Invalid arguments."
	  in 
	  VReg.inc rf size_of_closure;
	  VBuiltin(f,rf)
	end
    | _ -> failwith "Builtins \"mark\" : Invalid arguments."
  in 
  let brf =  Interp.VReg.newreg global_reg in
  VReg.inc brf size_of_closure;
  VBClosure(_mark, brf)

let type_of_mark:rtype_scheme =
  let rf = newRegVar () in
  let rs = newRegVar () in
  let e1 = newEffVar () in
  Forall([rf],[rf],[e1],
	 (new_FuncType 
	    ([new_Type ()],else_Type ())
	    (e1,[])
	    (new_Type ())
	    rf),
	 rs)

(* ---------------------------------------------------------------------------- *)

(** Ȥ߹ߴؿ *)
                      (* ScmǤ̾,ѥ̾,, *)
let builtin_functions : (string * string * scmval * rtype_scheme) list =
  [("+",              "builtin_plus",      plus,             type_of_plus);
   ("-",              "builtin_minus",     minus,            type_of_minus);
   ("*",              "builtin_mul",       mul,              type_of_mul);
   ("/",              "builtin_div",       div,              type_of_div);
   ("cons",           "builtin_cons",      cons,             type_of_cons);
   ("list",           "builtin_list",      list,             type_of_list);
   ("car",            "builtin_car",       car,              type_of_car);
   ("cdr",            "builtin_cdr",       cdr,              type_of_cdr);      
   ("cos",            "builtin_cos",       built_cos,        create_type_of_num_to_num ());
   ("sin",            "builtin_sin",       built_sin,        create_type_of_num_to_num ());
   ("tan",            "builtin_tan",       built_tan,        create_type_of_num_to_num ());
   ("atan",           "builtin_atan",      built_atan,       create_type_of_num_to_num ());
   ("sqrt",           "builtin_sqrt",      built_sqrt,       create_type_of_num_to_num ());
   ("truncate",       "builtin_truncate",  built_truncate,   create_type_of_num_to_num ());
   ("floor",          "builtin_floor",     built_floor,      create_type_of_num_to_num ());
   ("abs",            "builtin_abs",       built_abs,        create_type_of_num_to_num ());
   ("set-car!",       "builtin_setcar",    setcar,           type_of_setcar);      
   ("set-cdr!",       "builtin_setcdr",    setcdr,           type_of_setcdr);      
   ("make-vector",    "builtin_makevec",   makevec,          type_of_makevec);
   ("vector-ref",     "builtin_vecref",    vecref,           type_of_vecref);
   ("vector-set!",    "builtin_vecset",    vecset,           type_of_vecset);
   ("write",          "builtin_write",     write,            type_of_write); 
   ("display",        "builtin_scm_display",scm_display,     type_of_scm_display); 
   ("=",              "builtin_matg_equal",math_equal,       type_of_math_equal);
   ("eq?",            "builtin_eq",        eq,               type_of_eq);
   ("<",              "builtin_less_than", less_than,        type_of_less_than);
   ("<=",             "builtin_less_eq",   less_eq,          type_of_less_eq);
   (">",              "builtin_greater_than",   greater_than, type_of_greater_than);
   (">=",             "builtin_greater_eq",     greater_eq,   type_of_greater_eq);
   ("pair?",          "builtin_pair",       pair,             type_of_pair);
   ("null?",          "builtin_qnull",      qnull,            type_of_qnull);
   ("open-input-file",  "builtin_open_in",  scm_open_in,      type_of_scm_open_in);
   ("close-input-port", "builtin_close_in", scm_close_in,     type_of_scm_close_in);
   ("open-output-file", "builtin_open_out", scm_open_out,     type_of_scm_open_out);
   ("close-output-port","builtin_close_out",scm_close_out,    type_of_scm_close_out);
   ("read",           "builtin_scm_read",   scm_read,         type_of_scm_read);    
   ("mark",           "builtin_mark",       mark,             type_of_mark);    
   ("not",            "builtin_scm_not",    scm_not,          type_of_scm_not);    
   ("file-exists?",   "builtin_scm_file_exists", scm_file_exists,  type_of_scm_file_exists);
   ("delete-file",    "builtin_scm_delete_file", scm_delete_file,  type_of_scm_delete_file)    
 ]


(** Ѥ ѿ *)
let predefined_variables = 
  List.map (function (w,x,y,z) -> w) builtin_functions

(** Ȥ߹ߴؿ stype env *)
let builtin_senv = 
  List.map (function (w,x,y,z) -> (w,rtypescm_to_stypescm z)) builtin_functions
    
(** Ȥ߹ߴؿ rtype_env *)
let builtin_renv = 
  List.map (function (w,x,y,z) -> (w,z)) builtin_functions
    
    
(** Ȥ߹ߴؿ venv *)
let builtin_venv : venv = 
  ([],
   List.map (function (w,x,y,z) -> (w,ref y)) builtin_functions
  )
