;-----------------------------------------------------------------------------
;       Ray Tracing Program for chez
;
;    original program by Ryoji Kawamichi
;            arranged by Motohico Nanano
;
;               rt.scm
;
;         last change : 1996/4/8
;-----------------------------------------------------------------------------

;   $B%a%$%s%W%m%0%i%`(B
;
;   arctan
;   sgn
;   rt

;------------------------------------------------------------------------------
;       Ray Tracing Program for chez
;
;    original program by Ryoji Kawamichi
;            arranged by Motohico Nanano
;
;               Compiler.scm
;
;         last change : 1996/4/8
;-----------------------------------------------------------------------------

;------------------------------------------------------------------
; $BF1$8%W%m%0%i%`$rHI$N%3%s%Q%$%i$GF0$+$;$k$h$&$K$9$k$?$a$N4X?t(B
; $B%3%s%Q%$%i$K$+$1$k$H$-$K$O30$9!#(B
;------------------------------------------------------------------

;$BIbF0>.?tE@?t1i;;MQ$N4X?t(B

(define CR #\newline)
(define SPACE #\space)

(define (newline) (display CR))

(define (error x) #f)

;--------------------------------------------------------------------
;      - : $BId9g$NH?E>(B , - $B$h$j$bB.$$!#(B  
;--------------------------------------------------------------------

;--------------------------------------------------------------------
;      fsqr : $B#x$NFs>h$rJV$94X?t(B
;--------------------------------------------------------------------
(define (fsqr x) (* x x))

;--------------------------------------------------------------------
;  != : not = 
;--------------------------------------------------------------------
(define (!= a b) (not (= a b)))
(define f!= !=)


;--------------------------------------------------------------------
;       $B@0?t!"IbF0>.?tE@?t(B $B4V$NJQ49(B
;--------------------------------------------------------------------
;(define (int->float x) x)
;(define float->int (lambda (x) (inexact->exact (round x))))
(define float->int truncate)
;$B%3%s%Q%$%i$H$NBP1~(B
;(load "Compiler.scm")

;$BIbF0>.?tE@1i;;!"Hf3S$N2s?t$rD4$Y$k4X?t(B
;$B$3$l$r;HMQ$9$k;~$K$O>e$N(BCompiler.scm$B$r(Bload$B$7$J$$$3$H!#(B
;$B$^$?!"4X?t(B rt $BFb$N(B2$B2U=j$N%3%a%s%H$rJQ99$9$kI,MW$,$"$k!#(B
;(load "CompilerCheck.scm")


;--------------------------------------------------------------------
; $B!}(B $B%f!<%F%#%j%F%#MQ$N4X?t(B
;--------------------------------------------------------------------

;--------------------------------------------------------------------
; arctan :  arctan 
;--------------------------------------------------------------------

;$B3F<+<BAu$9$Y$7!#(B
;(define (arctan x) ...)

;--------------------------------------------------------------------
;      sgn : $B#x$NId9f$rJV$94X?t(B
;--------------------------------------------------------------------
(define (sgn x) 
  (cond ((> x 0.0)  1.0)
	((< x 0.0) -1.0)
	(else x)))



;--------------------------------------------------------------------
; $B!}(B $B%0%m!<%P%kJQ?t$N@k8@(B
;--------------------------------------------------------------------

;$B%*%V%8%'%/%H(B $B$N%G!<%?$rF~$l$k%Y%/%H%k!J:GBg(B60$B8D!K(B

(define object (make-vector 60))

;$B%*%V%8%'%/%H(B $B$N%G!<%?$rF~$l$k%Y%/%H%k$N=i4|2=(B $B!J3F(B20$B8D$N%G!<%?!K(B
(define (set-object i)
  (if (< i 60)
      (begin
	(vector-set! object i (make-vector 20))
	(set-object (+ i 1)))
      ))

; size = (x$B<4$NAv::@~K\?t(B . y$B<4$NAv::@~K\?t(B)

(define size (cons 128 128))

;$B<B9T;~%*%W%7%g%s(B

(define dbg (list #f))
(define sh  (list #t))

; Screen$B$N:BI8(B
(define Screen (make-vector 3))

;$B;kE@$N:BI8!J(Bofs$B$J$7!K(B
(define Vp     (make-vector 3))

;$B;kE@$N:BI8(B (ofs$B$"$j(B)
(define View   (make-vector 3))

;$B8w@~%Y%/%H%k!JC10L%Y%/%H%k!K!a8w$N8~$-(B
(define Light  (make-vector 3))

;$B=hM}$K;HMQ$9$k!#(BcosV1,sinV1,cosV2,sinV2$B$r3JG<(B

;(cosV1 . cosV2)
(define cos-V (cons 0 0))

;(sinV1 . sinV2)
(define sin-V (cons 0 0))

;$B6@LL$N%O%$%i%$%H6/EY(B $B!JI8=`$G(B 255$B!K(B
(define beam (list 0))

;AND$B%M%C%H%o!<%/(B $B$N%G!<%?$rF~$l$k%Y%/%?!J:GBg(B50$B8D!K(B

(define and-Net (make-vector 50))

;OR$B%M%C%H%o!<%/(B
(define or-Net (list 0))



;-------------------------------------------------------------------
; $B!}(B $B;HMQ$9$kB>$N4X?t72$N%m!<%I(B
;-------------------------------------------------------------------

;$B%G!<%?$rFI$_9~$`4X?t(B
;-----------------------------------------------------------------------------
;       Ray Tracing Program for chez
;
;    original program by Ryoji Kawamichi
;            arranged by Motohico Nanano
;
;               ReadData.scm
;
;         last change : 1996/4/8
;-----------------------------------------------------------------------------

; $B%U%!%$%k$+$i%G!<%?$rFI$_9~$`4X?t72(B
; Read-Parameter    <-  $B30It$+$i8F$P$l$k(B
;
; rad
; Read-Environ
; Read-all-Object
; Read-Object
; Read-Nth-Object
; Modify-Object
; Modify-Nth-Object
; Read-Net-item
; Read-Or-Network
; Read-And-Network
(define (call-with-input-file filename proc)
  (let ((inport (open-input-file filename)))
    (begin (proc inport)
	   (close-input-port inport))))
(define (call-with-output-file filename proc)
  (let ((outport (open-output-file filename)))
    (begin (proc outport)
	   (close-output-port outport))))

(define (caar p)
  (car (car p)))
(define (cdar p)
  (cdr (car p)))


;--------------------------------------------------------------------
; rad :  $B3QEY$+$i%i%8%"%s$KJQ49$9$k4X?t(B
;--------------------------------------------------------------------

;x /180.0 * pi(= 3.1415927)

(define (rad x) (* x 0.017453293))

;--------------------------------------------------------------------
; Read-Parameter :  $B%U%!%$%k(B InputFile $B$+$i%G!<%?$rFI$_9~$`!#(B
;--------------------------------------------------------------------

(define (Read-Parameter InputFile)

  (call-with-input-file InputFile
    (lambda (port)
      
      (begin
	(if (null? port) (error "input file error!" InputFile))

	;$B%9%/%j!<%s!"8w8;$J$I$N%G!<%?$NFI$_9~$_(B
	(Read-Environ port)
	(write "Read-Environ OK")(newline)

	;$B%*%V%8%'%/%H$N%G!<%?$NFI$_9~$_(B
	(Read-All-Object port)
	(write "Read-All-Object OK")(newline)
  
	;AND$B%M%C%H%o!<%/$NFI$_9~$_(B
	(Read-And-Network 0 port)
	(write "Read-And-Network OK")(newline)
	
	;OR$B%M%C%H%o!<%/$NFI$_9~$_(B
	(set-car! or-Net (Read-Or-Network port))
	(write "Read-Or-Network OK")(newline)

	))))


;--------------------------------------------------------------------
;  Read-Environ : $B%9%/%j!<%s$K4X$9$k%Q%i%a!<%?$rFI$_9~$`(B
;--------------------------------------------------------------------

(define (Read-Environ port)
  (begin

					;$B%9%/%j!<%sCf?4$N:BI8$r%;%C%H(B
    (vector-set! Screen 0 (read port))
    (vector-set! Screen 1 (read port))
    (vector-set! Screen 2 (read port))
    
    (let* ((v1  (rad (read port)))
	   (cv1 (cos v1))  ;
	   (sv1 (sin v1))  ;
	   
	   (v2  (rad (read port)))
	   (cv2 (cos v2))  ;
	   (sv2 (sin v2))  ;
	   
	   (nl  (read port))
	   
	   (l1  (rad (read port)))
	   (cl1 (cos l1))
	   (sl1 (sin l1))
	   
	   (l2  (rad (read port)))
	   (cl2 (cos l2))
	   (sl2 (sin l2)))

      (begin
	(set-car! beam (read port))
	
	;$B8w@~%Y%/%H%k$N%;%C%H(B
	(vector-set! Light 0 (* cl1 sl2))
	(vector-set! Light 1 (- sl1))
	(vector-set! Light 2 (* cl1 cl2))

	;$B;kE@0LCV%Y%/%H%k!J%m!<%+%k:BI8!K$N%;%C%H(B
	(vector-set! Vp 0 (* cv1 sv2  -200.0))
	(vector-set! Vp 1 (* (- sv1) -200.0))
	(vector-set! Vp 2 (* cv1 cv2  -200.0))

	;$B=hM}$K;HMQ$9$k(B cos,sin $B$NMQ0U(B
	(set-car! cos-V cv1)
	(set-car! sin-V sv1)
	;(write sin-V)(newline)
	(set-cdr! cos-V cv2)
	(set-cdr! sin-V sv2)

	;$B;kE@0LCV%Y%/%H%k!J%o!<%k%I:BI8!K$N%;%C%H(B
	(vector-set! View 0 
		     (+ (vector-ref Vp 0) (vector-ref Screen 0)))
	(vector-set! View 1
		     (+ (vector-ref Vp 1) (vector-ref Screen 1)))
	(vector-set! View 2
		     (+ (vector-ref Vp 2) (vector-ref Screen 2)))

	))))

;--------------------------------------------------------------------
;  Read-Nth-Object : $B%U%!%$%k$+$i(Bn$B8DL\$N%*%V%8%'%/%H$rFI$_9~$`4X?t(B
;--------------------------------------------------------------------

(define (Read-Nth-Object n port)

  (let ((Texture (read port)))
    (if (!= Texture -1) 
	
	(let ((obj (vector-ref object n)))
	  
	  (begin
	    (vector-set! obj 0 Texture)
	    (vector-set! obj 1 (read port))
	    (vector-set! obj 2 (read port))
	    
	    ;xscheme$B$N>l9g(B let$BJ8(B $B$G$N(B $B6I=jJQ?t$X$NBeF~$N:]$K(B
	    ;(read port)$B$,J#?t$"$k$H:G8e$N(B(read port)$B$NCM(B $B$,<h$i$l$k(B
	    ;$B$D$^$j!"(B(read port)$B$,O"B3$GI>2A$5$l$k>l9g!"@h$NCM$OL5;k(B
	    ;$B$5$l$k!#4X?t$X$NBeF~$N:]$K$b5$$r$D$1$k$3$H!#(B

	    (let ((rtset? (if (= (read port) 1) #t #f)))
	      
	      (begin
		(vector-set! obj  3 rtset?)
		(vector-set! obj  4 (read port))
		(vector-set! obj  5 (read port))
		(vector-set! obj  6 (read port))
		(vector-set! obj  7 (read port))
		(vector-set! obj  8 (read port))
		(vector-set! obj  9 (read port))
		(vector-set! obj 10 (read port))
		(vector-set! obj 11 (read port))
		(vector-set! obj 12 (read port))
		(vector-set! obj 13 (read port))
		(vector-set! obj 14 (read port))
		(vector-set! obj 15 (read port))
		
		;$B!}(B $B%*%V%8%'%/%H$r2sE>$5$;$k;~(B
		(if rtset?
		    (begin
		      (vector-set! obj 16 (read port))
		      (vector-set! obj 17 (read port))
		      (vector-set! obj 18 (read port))
		      ))
		
		#t))))
	#f)))

;--------------------------------------------------------------------
;  Modify-Nth-Object 
;
;    $BFI$_9~$s$@%*%V%8%'%/%H$N%G!<%?$r(B
;           $BJ?LL$N>l9g!"(Ba^2 + b^2 + c^2 = 1 $B$K$J$k$h$&$K=$@5(B
;           $B#2<!6JLL$N>l9g(B x^2/a + y^2/b + Z^2/c = 1$B$H$J$k$h$&$K=$@5(B 
;
;    $B%*%V%8%'%/%H$N2sE>$,I,MW$J>l9g$K$O2sE>$r%5%]!<%H$9$k!#(B
;--------------------------------------------------------------------

(define (Modify-Nth-Object n port)

  (let* ((obj    (vector-ref object n))
	 (Form   (vector-ref obj 1))
	 (rtset? (vector-ref obj 3)))
    
    (begin
      
      ;$B!}(B $B%Q%i%a!<%?(BA,B,C$B$OJ*BN$N<oN`$K$h$C$F$OJQ99$NI,MW$"$j(B
      
      ;Form=3 $B%G!<%?$O(B2$B<!6JLL$,(B1$BHVB?$$$+$i@h$K!#(B
      (cond 
       
       ((= Form 3)
	(let ((A (vector-ref obj 4))
	      (B (vector-ref obj 5))
	      (C (vector-ref obj 6)))
	  (begin
	    (vector-set! obj 4 (if (= A 0.0) 0.0
				   (/ (sgn A)(fsqr A))))
	    (vector-set! obj 5 (if (= B 0.0) 0.0
				   (/ (sgn B)(fsqr B))))
	    (vector-set! obj 6 (if (= C 0.0) 0.0
				   (/ (sgn C)(fsqr C))))
	    )))
     
       ;Form=2 $BJ*BN$,J?LL$N>l9g$N=$@5(B
       ((= Form 2)
	(let* ((A (vector-ref obj 4))
	       (B (vector-ref obj 5))
	       (C (vector-ref obj 6))
	       (Q (sqrt (+ (fsqr A)(fsqr B)(fsqr C)))))
	  (if (= (vector-ref obj 10) 1.0)
	      (begin
		(vector-set! obj 10 -1.0)
		(vector-set! obj 4 (/ (- A) Q))
		(vector-set! obj 5 (/ (- B) Q))
		(vector-set! obj 6 (/ (- C) Q)))
	      (begin 
		(vector-set! obj 4 (/ A Q))
		(vector-set! obj 5 (/ B Q))
		(vector-set! obj 6 (/ C Q))
		)))))
           
      ;Form=1 $BJ*BN$,$=$NB>$N;~$O=$@5$J$7!#(B
      
      ;$B!}(B $B%*%V%8%'%/%H$r2sE>$5$;$k;~(B
      (if rtset? 
	  
	  ;$B2sE>3Q$NFI$_9~$_(B 
	  (let* ((RotX (vector-ref obj 16))
		 (RotY (vector-ref obj 17))
		 (RotZ (vector-ref obj 18))
	  			   
		 ;$B=hM}$K;HMQ$9$k(Bcos,sin$B$N:n@.(B
		 (cx (cos (rad RotX)))
		 (sx (sin (rad RotX)))
		 (cy (cos (rad RotY)))
		 (sy (sin (rad RotY)))
		 (cz (cos (rad RotZ)))
		 (sz (sin (rad RotZ)))
		 
		 ;3$B<!852sE>$N9TNs(B
		 (r0 (* cy cz))
		 (r1 (- (* sx sy cz) (* cx sz)))
		 (r2 (+ (* cx sy cz) (* sx sz)))
		 (r3 (* cy sz))
		 (r4 (+ (* sx sy sz) (* cx cz)))
		 (r5 (- (* cx sy sz) (* sx cz)))
		 (r6 (- sy))
		 (r7 (* sx cy))
		 (r8 (* cx cy))
		 
		 (ao (vector-ref obj 4))
		 (bo (vector-ref obj 5))
		 (co (vector-ref obj 6)))
	    
	    (begin
	      
	      ;$B%Q%i%a!<%?$NJQ99(B
	      (vector-set! obj 4 (+ (* ao (fsqr r0))(* bo (fsqr r3))(* co (fsqr r6))))
	      (vector-set! obj 5 (+ (* ao (fsqr r1))(* bo (fsqr r4))(* co (fsqr r7))))
	      (vector-set! obj 6 (+ (* ao (fsqr r2))(* bo (fsqr r5))(* co (fsqr r8))))
	    
	      ;$B2sE>3Q$NJQ99(B
	      (vector-set! obj 16 (* 2.0 (+ (* ao r1 r2) (* bo r4 r5) (* co r7 r8))))
	      (vector-set! obj 17 (* 2.0 (+ (* ao r0 r2) (* bo r3 r5) (* co r6 r8))))
	      (vector-set! obj 18 (* 2.0 (+ (* ao r0 r1) (* bo r3 r4) (* co r6 r7))))
	      ))))))
  

;--------------------------------------------------------------------
; Read-Object
;
; $B%*%V%8%'%/%H$N%G!<%?$rFI$_9~$_!"(B
; $B:G8e$N%*%V%8%'%/%H$NF~$C$?%Y%/%?$NHV9f$rJV$9!#(B
;
;--------------------------------------------------------------------

(define (Read-Object n port)
  (if (< n 61)
      (if (Read-Nth-Object n port)
	  (Read-Object (+ n 1) port)
	  (- n 1))
      (error "data overflow")
      ))

;--------------------------------------------------------------------
; Modify-Object : $B%*%V%8%'%/%H$NF~$C$?%Y%/%?$r(B0$B$N%G!<%?$^$G=g$K=$@5(B
;--------------------------------------------------------------------

  (define (Modify-Object n port)
    (if (>= n 0)
	(begin 
	  (Modify-Nth-Object n port)
	  (Modify-Object (- n 1) port))
	#f))

;--------------------------------------------------------------------
; Read-All-Object : $B%*%V%8%'%/%H$N%G!<%?$rFI$_9~$_I,MW$K1~$8=$@5(B
;--------------------------------------------------------------------

(define (Read-All-Object port)
  (Modify-Object (Read-Object 0 port) port))


;--------------------------------------------------------------------
; Read-Network : $B#A#N#D!"#O#R%M%C%H%o!<%/$rFI$_9~$_!"(B
;--------------------------------------------------------------------

;$B%M%C%H%o!<%/Cf$N%"%$%F%`$r(B -1$B$^$G$r=8$a%j%9%H$K$9$k!#(B
(define (Read-Net-Item port)
  (let ((item (read port)))
    ;(write 'item)(write item)(newline)
    (if (= item -1)
	'()
	(cons item (Read-Net-Item port)))))

;OR$B%M%C%H%o!<%/$r=g$KJB$Y$?%j%9%H$r:n$k!#(B
(define (Read-Or-Network port)
  (let ((net (Read-Net-Item port)))
    (if (null? net)
	'()
	(cons net (Read-Or-Network port)))))

;AND$B%M%C%H%o!<%/$r=g$K%Y%/%?(BandNet$B$K3JG<!#(B
(define (Read-And-Network n port)
  (let ((net (Read-Net-Item port)))
    (if (null? net)
	#t
	(begin
	  (vector-set! and-Net n net) 
	  (Read-And-Network (+ n 1) port)))))


;$BE@$r%l%$%H%l!<%9$9$k4X?t(B
;(load "Scan.scm")
;------------------------------------------------------------------------------
;       Ray Tracing Program for chez
;
;    original program by Ryoji Kawamichi
;            arranged by Motohico Nanano
;
;               Scan.scm
;
;         last change : 1996/4/8
;-----------------------------------------------------------------------------

; $B%9%/%j!<%s$NA4E@$N%9%-%c%s$r9T$J$&4X?t72(B
;
;Scan-Start <-$B30It$+$i8F$P$l$k!#(B
;
;Write-PPM-Header
;Write-RGB
;Scan-Line
;Scan-Point
;RayTracing
;
;$B;kE@$+$i%9%/%j!<%s>e$NA4E@$KBP$7!"%l%$%H%l!<%9$r;O$a$k!#(B
; y$B<4$NAv::@~$N%*%U%;%C%H$O(BBASIC$B$H0c$$<B9T;~%Q%i%a!<%?$K4^$^$l$F$$$J(B
;$B$$$?$a(B 
;
;  x$B<4(B 1 $B$+$i(B SizeX $B$KBP1~$9$kAv::@~>e$rD4$Y$k!#(B
;  y$B<4(B 1 $B$+$i(B SizeY $B$KBP1~$9$kAv::@~>e$rD4$Y$k!#(B 



;-------------------------------------------------------------------
; Scan-Start :
;  $B!&=PNO%U%!%$%k$r%*!<%W%s(B
;  $B!&(BPPM$B%U%)!<%^%C%H$GI,MW$J(B Header $B$r=q$-9~$`!#(B
;  $B!&(BScan-Line$B$r:F5"E*$KMQ$$(By$B<4$NA4Av::@~>e$rD4$Y$k!#(B
;  $B!&=PNO%U%!%$%k$r%/%m!<%:$9$k!#(B
;-------------------------------------------------------------------

(define (Scan-Start OutFileName)
  (begin
    (if (file-exists? OutFileName)
	(delete-file OutFileName)
	)
    (let ((SizeX (car size)))
      (call-with-output-file OutFileName
	(lambda (OutPort)
	  (begin
	    (Write-PPM-Header OutPort)
	    (Scan-Line 0 (/ 128.0 SizeX) (/ SizeX 2.0) OutPort)
	    ))))))



;--------------------------------------------------------------------
;  .PPM$B%U%!%$%k$N%X%C%@!<$r=q$-9~$`4X?t(B
;--------------------------------------------------------------------

(define (Write-PPM-Header OutPort)
  (begin 
    (display "P3"    OutPort)
    (display CR      OutPort)
    (display (car size) OutPort)
    (display " "     OutPort)
    (display (cdr size) OutPort)
    (display " "     OutPort)
    (display 255     OutPort)
    (display CR      OutPort)))

;--------------------------------------------------------------------
;  RGB $BCM$r%U%!%$%k$K=q$-9~$`4X?t(B
;--------------------------------------------------------------------

(define (Write-RGB OutPort red green blue)
  (begin 
    (display red   OutPort)
    (display " "   OutPort)
    (display green OutPort)
    (display " "   OutPort)
    (display blue  OutPort)
    (display " "   OutPort)
    (display  CR   OutPort)))
  
;-------------------------------------------------------------------
; Scan-Line : $B#1$D$N%i%$%s!J(By$B0lDj!K$K$D$$$F%9%-%c%s$9$k<jB3$-!J:F5"!K(B
;-------------------------------------------------------------------

;rgb : $B$"$kE@$N?'$N%G!<%?(B
(define rgb (make-vector 3))

;Vscan $B%H%l!<%9$NJ}8~(B
(define Vscan (make-vector 3))

;ViewPoint $B%H%l!<%9$7;O$a$kE@(B
(define ViewPoint (make-vector 3))

; y$B<4(B scany $B$NAv::@~>e$r%9%-%c%s$9$k!#(B
; d      : $BAv::@~$N%T%C%A(B = 128/X$B<4$NAv::@~K\?t(B (car size)
; offset : $B??Cf$NAv::@~HV9f(B $B!"Av::@~$+$i:BI8$X$NJQ49$KMQ$$$k!#(B
;         = (car size)/2
; OutPort: $B=PNO%U%!%$%k$N%]!<%H(B

(define (Scan-Line scany d offset OutPort)
  (if (< scany (cdr size))
      (begin
	
	;$B%G%P%C%0%*%W%7%g%s!#<!$K%9%-%c%s$9$k(By$B<4J}8~$NAv::@~HV9f$r=PNO(B
	(if (car dbg) 
	    (begin (display "scanning y = ")
		   (display scany)
		   (display  CR)))
	
	;sscany $BD4$Y$kAv::@~$N(By$B:BI8!J0lHV>e(B(=(offset-1)*d)$B$rAv::@~$N(B0
	;$BHV$H$9$k!#(B
	
	(let* ((sscany (* d (- offset 1.0 scany)))
	       
	       ;40000.0 = (fsqr -200.0)
	       ;met1 $B;kE@$+$iAv::@~$X$N5wN%$N(B2$B>h(B
	       
	       (met1 (+ (fsqr sscany) 40000.0))
	       
	       ;wscanx $B;kE@$+$iAv::@~$^$G$N%Y%/%H%k$N(Bx$B@.J,(B
	       ;wscanz $B;kE@$+$iAv::@~$^$G$N%Y%/%H%k$N(Bz$B@.J,(B
	       
	       (wscanx (- (* sscany (car sin-V)(cdr sin-V)) 
			   (vector-ref Vp 0))) 
	       (wscanz (- (* sscany (car sin-V)(cdr cos-V)) 
			   (vector-ref Vp 2)))
	       )
	  ;x$BJ}8~$K%9%-%c%s3+;O(B
	  (begin 
	    (Scan-Point 0 wscanx wscanz sscany met1 d offset OutPort))
	
	(Scan-Line (+ scany 1) d offset OutPort)))))



;-----------------------------------------------------------
; $B!}(B $B4X?t(B Scan-Point
;     x$B:BI8$r:F5"E*$KA4ItD4$Y!"3FE@$N(B rgb$B$r=PNO%U%!%$%k$K=q$-9~$`4X?t(B
;       wsx   : $B;kE@$+$iAv::@~$^$G$N%Y%/%H%k$N(Bx$B@.J,(B
;       wsz   : $B;kE@$+$iAv::@~$^$G$N%Y%/%H%k$N(Bz$B@.J,(B
;       met1  : $B;kE@$+$iAv::@~$X$N5wN%$N(B2$B>h(B
;	scanx : $BD4$Y$kAv::@~HV9f!J(Bx$B<4!K(B
;-----------------------------------------------------------
(define (Scan-Point scanx wsx wsz sscany met1 d offset OutPort)
  (if (= scanx (car size))
      #f
      
      ;sscanx = d*(scanx-offset)  : $BAv::@~HV9f$+$i(Bx$B:BI8$X$NJQ49(B
      ;metric : $B;kE@$+$iD4$Y$kE@$^$G$N5wN%$N5U?t(B
      
      (let* ((sscanx (* d (- scanx offset)))
	     (metric (sqrt (+ (fsqr sscanx) met1))))
	
	(begin
	  
	  ;Vscan : $B%H%l!<%9$N:G=i$O!";kE@$+$iD4$Y$kE@$X$NJ}8~%Y%/%H%k(B
	  ;       $B$NC10L%Y%/%H%k(B
	  (vector-set! Vscan 0
		       (/ (+ (* sscanx (cdr cos-V)) wsx) metric))
	  (vector-set! Vscan 1 (/ (- (* sscany (car cos-V))
				       (vector-ref Vp 1)) metric))
	  (vector-set! Vscan 2 
		       (/ (+ (* (- sscanx)(cdr sin-V)) wsz) 
			   metric))
	  ;ViewPoint : $B%H%l!<%9$N:G=i$O;kE@$N0LCV(B
	  (vector-set! ViewPoint 0 (vector-ref View 0))
	  (vector-set! ViewPoint 1 (vector-ref View 1))
	  (vector-set! ViewPoint 2 (vector-ref View 2))
	  
	  ;$B?'$N=i4|2=(B	    
	  (vector-set! rgb 0 0.0)
	  (vector-set! rgb 1 0.0)
	  (vector-set! rgb 2 0.0)
	  
	  ;(write (vector-ref ViewPoint 0))(newline)
	  ;$B;kE@$+$i%9%/%j!<%s$NE@$K8~$1$F%H%l!<%9(B
	  (RayTracing ViewPoint Vscan 0 1.0 rgb)
	  
	  ;RGB$BCM$NJd@5!u=q9~(B
	  (let* ((Red   (vector-ref rgb 0))
		 (Green (vector-ref rgb 1)) 
		 (Blue  (vector-ref rgb 2))
		 (red   (if (> Red   255.0) 255 (float->int Red  )))
		 (green (if (> Green 255.0) 255 (float->int Green)))
		 (blue  (if (> Blue  255.0) 255 (float->int Blue )))
		 )
	    (Write-RGB OutPort red green blue))
	  
	  ;$B<!$NE@$K?J$`!J:F5"!K(B
	  (Scan-Point (+ scanx 1) wsx wsz sscany met1 d offset OutPort)
	  ))))

;-----------------------------------------------------------
; RayTracing : $BE@(B ViewPoint $B$+$i%Y%/%H%k(B Vscan $BJ}8~$K%H%l!<%9$7!"(B
;              $B$=$3$,2??'$+$r7W;;$7!"(Brgb$B$K3JG<$9$k4X?t(B 
;
;	ViewPoint	: $B%H%l!<%9$7;O$a$kE@(B
;	Vscan		: $B%H%l!<%9$NJ}8~!JC10L%Y%/%H%k!K(B
;	nref		: $B2?2sL\$NH?<M$+!J=i4|CM(B0$B!K(B
;	energy		: $B%(%M%k%.!<$N8:?j!J=i4|CM(B1$B!K(B
;			$BH?<M$K$h$j8:?j$9$k!#(B
;	rgb		: $B%H%l!<%9$7$??'$rF~$l$kJQ?t$r;XDj(B
;-----------------------------------------------------------

(define (RayTracing ViewPoint Vscan nref energy rgb)
  (if (<= nref 4)
      
      ;crashed? = $B$V$D$+$C$?%*%V%8%'%/%H$NHV9f(B $B$H(B $B8rE@$N:BI8(B
      ;$B$V$D$+$C$F$$$J$+$C$?$i!"(B#f
      
      (let ((crashed? (tracer ViewPoint Vscan)))  ;$B$V$D$+$C$?$+!)(B
	
	;$B!}(B $BH?<M$,$J$/2?$K$b$V$D$+$i$J$$;~!"=i4|CM(B=(0.0 0.0 0.0)=$B0E0G(B
	
	;$B!}(B $BH?<M$N8e!"2?$K$b$V$D$+$i$J$$;~(B,$B8w8;$+$i$N8w$N1F6A$GL@$k$5(B
	;$B$,7h$^$k!#(B
	
	; hl0 $B8w8;$H%H%l!<%9J}8~$NFb@Q(B
	; hl $BH?<MLL$KFO$/8w(B
	;   $B3QEY$,(B90$BEY0JFb(B = $BH?<MLL$K8w$,FO$+$J$$!#(B= $B0E0G(B = 0.0
	;   $B3QEY$,(B90$BEY$h$jBg$-$$(B = $BH?<MLL$K8w$,FO$/!#$=$NBg$-$5(B = hl0
	(if (and (not crashed?) (!= nref 0))
	    (let* ((hl0 
		    (- (+ (* (vector-ref Vscan 0) 
				   (vector-ref Light 0)) 
			       (* (vector-ref Vscan 1) 
				   (vector-ref Light 1)) 
			    (* (vector-ref Vscan 2) 
				(vector-ref Light 2)))))
		   (hl (if (< hl0 0.0) 0.0 hl0))
		   
		   ;hl$B$N(B 3$B>h(B $BJ,!"8w$,<e$^$k$h$&$@!#(B
		   
		   (ihl (* hl hl hl energy (car beam))))
	      
	      (begin
		(vector-set! rgb 0 (+ (vector-ref rgb 0) ihl))
		(vector-set! rgb 1 (+ (vector-ref rgb 1) ihl))
		(vector-set! rgb 2 (+ (vector-ref rgb 2) ihl)))))
	
	;$B!}(B $B%*%V%8%'%/%H$K$V$D$+$C$?;~(B

	(if crashed?

	    ;P  : $B8rE@(B
	    ;m  : $B$V$D$+$C$?%*%V%8%'%/%H$NHV9f(B
	    ;NV : $B%*%V%8%'%/%H(Bm$B$NE@(BP$B$K$*$1$kK!@~%Y%/%H%k(B
	    
	    (let* ((P (cdr crashed?))    ;$B8rE@(B
		   (m (car crashed?))    ;$B$V$D$+$C$?%*%V%8%'%/%H(B
		   (NV (Get-NVector m Vscan P)))
	      
	      ;$BJ*BN$K8w$,Ev$?$C$F$$$k$+!#(B
	      ;br : $BK!@~%Y%/%H%k$H8w@~$NFb@Q(B
	      ;br1 : $B%*%V%8%'%/%H$KEv$?$k8w(B
	      ;  $B3QEY$,(B90$BEY0JFb(B = $B8w$,Ev$?$i$J$$!#(B= 0.0
	      ;  $B3QEY$,(B90$BEY$r1[$($k(B = $B8w$,Ev$?$k!#(B
	      
	      (let* ((br 
		      (- (+ (* (vector-ref NV 0) 
				     (vector-ref Light 0)) 
				 (* (vector-ref NV 1) 
				  (vector-ref Light 1))
				 (* (vector-ref NV 2) 
				     (vector-ref Light 2)))))
		     (br1 (if (< br 0.0) 0.0 br))
		     
		     (bright 
		      ;$B1F%*%W%7%g%s$,$"$k$J$i1F$,$"$k$+$I$&$+D4$Y$k(B
		      (if (and (car sh)
			       (Shadow-Check-One-Or-Matrix (car or-Net) P))
			  ;$B1F$J$i$P(B0.0
			  0.0
			  ;$B1F$G$J$1$l$PI=LLMpH?<MN($rMQ$$!"I=LLMpH?<M(B
			  ;$B$r$7$?;D$j$N%(%M%k%.!<$rF@$k!#(B
			  (* (+ br1 0.2) energy (vector-ref m 11)))))

		(begin
		;$B%F%/%9%A%e%"$r7W;;(B
		(utexture m P)
		      
		;bright$B$rI=LL$N?'$K$+$1?'$rF@$k!#(B
		(vector-set! rgb 0 (+ (vector-ref rgb 0) 
				       (* bright (vector-ref m 13))))
		(vector-set! rgb 1 (+ (vector-ref rgb 1) 
				       (* bright (vector-ref m 14))))
		(vector-set! rgb 2 (+ (vector-ref rgb 2) 
				       (* bright (vector-ref m 15))))
		
		;$B%(%M%k%.!<$,;D$C$F$$$k$J$i!"H?<M$r7W;;(B
		;(object m 2)=$BI=LLFC@-(B $BMpH?<M$+6@LL(B
		
		(if (>= energy 0.1) 
		    (begin 
		      
		      (let ((w (* -2.0 
				   (+ (* (vector-ref Vscan 0) 
					   (vector-ref NV 0)) 
				       (* (vector-ref Vscan 1) 
					   (vector-ref NV 1)) 
				       (* (vector-ref Vscan 2) 
					   (vector-ref NV 2))))))
			(begin
			  
			  ;$BH?<M8e$N%H%l!<%9J}8~$r7W;;(B
			  
			  (vector-set! Vscan 0 
				       (+ (vector-ref Vscan 0)
					   (* w (vector-ref NV 0))))
			  (vector-set! Vscan 1 
				       (+ (vector-ref Vscan 1)
					   (* w (vector-ref NV 1))))
			  (vector-set! Vscan 2 
				       (+ (vector-ref Vscan 2) 
					   (* w (vector-ref NV 2))))
			  
			  (cond 
			   
			   ;$BMpH?<M(B
			   ;m2:$BI=LL(B m12:$BMpH?<MLL%O%$%i%$%H6/EY(B 
			   
			   ((= (vector-ref m 2) 1) 
			    (if (> (vector-ref m 12) 0.0)
				(begin
				  
				  ;$B%O%$%i%$%H$r7W;;$7!"6/$5$r2C$($k(B
				  (let* ((hl0 (- 0.0 
						  (+ (* (vector-ref Vscan 0)(vector-ref Light 0))
						      (* (vector-ref Vscan 1) (vector-ref Light 1)) 
						      (* (vector-ref Vscan 2) (vector-ref Light 2)))))
					 (hl (if (< hl0 0.0) 0.0 hl0))           
					 (ihl (* hl hl hl hl energy bright
						  (vector-ref m 12))))
				    
				    (begin
				      (vector-set! rgb 0 
						   (+ (vector-ref rgb 0) ihl))
				      (vector-set! rgb 1 
						   (+ (vector-ref rgb 1) ihl))
				      (vector-set! rgb 2 
						   (+ (vector-ref rgb 2) ihl)))))))
			   
			   ;$B6@LL(B	
			   ;$B$5$i$K%H%l!<%9$9$k!#(B
			   
			   ((= (vector-ref m 2) 2) 
			    
			    (let ((energy2 (* energy (- 1.0 (vector-ref m 11)))))
			      
			      (begin 
				(vector-set! ViewPoint 0 
					     (vector-ref P 0))
				(vector-set! ViewPoint 1
					     (vector-ref P 1))
				(vector-set! ViewPoint 2 
					     (vector-ref P 2))
				
				;$B%9%?!<%H%]%$%s%H$r8rE@$K!"H?<M$N8~$-$K:F$S%H%l!<%9(B
				(RayTracing ViewPoint Vscan (+ nref 1) energy2 rgb))))))))))))))))


;$B%*%V%8%'%/%H$H$N8rE@$,$"$k$+D4$Y$k!#(B
;(load "Tracer.scm")
;-----------------------------------------------------------------------------
;       Ray Tracing Program for chez
;
;    original program by Ryoji Kawamichi
;            arranged by Motohico Nanano
;
;               Tracer.scm
;
;         last change : 1996/4/8
;-----------------------------------------------------------------------------

;$B%H%l!<%9$9$k4X?t(B
;
; tracer <-$B30It$+$i8F$S=P$5$l$k(B
;
; Trace-Or-Network
; Solve-One-Or-Network
; Solve-Each-Element
;

(define tmin (list 1000000000.0))
(define result (cons #f (make-vector 3)))
(define endflag (list #f))

;-------------------------------------------------------------------
; $B4X?t(B Trace-Or-Network 
;   OR$B%M%C%H%o!<%/$N(B1$B$D$N(BOR-group$B$r<h$j=P$7(B
;       $B%l%s%8%W%j%_%F%#%V$K$D$$$F$NH=Dj$r9T$J$&!#(B
;
;       $B$5$i$K$=$N(BOR-group$B$K$D$$$FD4$Y$k!#(B
;-------------------------------------------------------------------

(define (Trace-Or-Network or-network)
  (if (null? or-network)
      '()
      (let ((range-primitive (caar or-network)))

	;$B%l%s%8%W%j%_%F%#%V$NH=Dj(B
	(if (= range-primitive 99)
	    
	    ;$B%l%s%8%W%j%_%F%#%V$,$J$$$N$GA4(Band-group$B$rH=Dj(B
	    (begin 
	      
	      (Solve-One-Or-Network (cdar or-network)))
	    
	    ;$B%l%s%8%W%j%_%F%#%V$K$V$D$+$i$J$1$l$P(Bor-group$BFb$N(B
	    ;$BA4(Band-group$B$H$V$D$+$i$J$$!#(B
	    (let ((t (solver range-primitive Vscan ViewPoint)))
	      ;(write 't)(write t)(newline)
	      ;$B%l%s%8%W%j%_%F%#%V$K$V$D$+$C$?;~(B
	      (if (and t (< t (car tmin))) 
		  (Solve-One-Or-Network (cdar or-network)))))
	
	(Trace-Or-Network (cdr or-network)))))

;--------------------------------------------------------------------
; $B4X?t(B Solve-One-Or-Network
;   1$B$D$N(B OR-group $B!J%l%s%8%W%j%_%F%#%V$r=|$/!K$NMWAG$N(BAND-group
;  $B$rA4$FD4$Y$k!#(B
;--------------------------------------------------------------------

(define (Solve-One-Or-Network or-group)
  (if (null? or-group)
      '()
      (let ((and-group (vector-ref and-Net (car or-group))))
	(begin
	  ;or$B%M%C%H%o!<%/$+$i(B1$B$D$N(BAND-group$B$NA4MWAG$rD4$Y$k!#(B
	  (set-car! endflag #f)
	  (Solve-Each-Element and-group and-group)

	  ;$B<!$N(BAND-group$B$X(B
	  (Solve-One-Or-Network (cdr or-group))))))

;--------------------------------------------------------------------
;$B4X?t(B Solve-Each-Element
;  $B$"$k%*%V%8%'%/%H$,!"%l%$%H%l!<%9$NJ}8~$KBP$7!"8rE@$,$"$k$+(B
; $B$I$&$+$rD4$Y$k!#(B
;--------------------------------------------------------------------

(define (Solve-Each-Element iand and-group)
  (if (null? iand)
      '()
      (let* ((iobj (car iand))
	     (t0 (solver iobj Vscan ViewPoint)))
	(begin ;(write 't0==)(write t0)(newline)
	       (if t0
		   (if (and (<= -0.1 t0) (< t0 (car tmin)))
		       (let* ((t (+ t0 0.01))
			      (Qx (+ (* (vector-ref Vscan 0) t) 
				     (vector-ref ViewPoint 0)))
			      (Qy (+ (* (vector-ref Vscan 1) t) 
				     (vector-ref ViewPoint 1)))
			      (Qz (+ (* (vector-ref Vscan 2) t) 
				     (vector-ref ViewPoint 2))))
			 (if (Check-All-Inside Qx Qy Qz and-group)
			     (begin 
			       (set-car! tmin t)
			       (let ((vec (cdr result)))
				 (begin
				   (vector-set! vec 0 Qx)
				   (vector-set! vec 1 Qy)
				   (vector-set! vec 2 Qz)))
			       (set-car! result (vector-ref object iobj)))
			     '()  ))
		       '())
		   (if (> (vector-ref (vector-ref object iobj) 10) 0.0) 
		       (set-car! endflag #t)
		       '() ))
	       (if (not (car endflag))
		   (Solve-Each-Element (cdr iand) and-group)
		   '() )))))

;--------------------------------------------------------------------
; tracer : $B%H%l!<%93+;OE@(B ViewPoint $B$+$i%9%-%c%sE@$^$G$NJ}8~%Y%/%H(B
;          $B%k(B Vscan $B$h$j!"8rE@(B R $B$H!"$V$D$+$C$?%*%V%8%'%/%H$rJV$9!#(B
;--------------------------------------------------------------------

(define (tracer ViewPoint Vscan)
  (begin
    (set-car! tmin 1000000000.0)
    (Trace-Or-Network (car or-Net))
    (let ((t (car tmin)))
      (if (and (>= t -0.1)(<= t 100000000.0))
	  result
	  #f))))

;$B%*%V%8%'%/%H$H$N8rE@$r5a$a$k4X?t(B
;(load "Solver.scm")
;------------------------------------------------------------------------------
;       Ray Tracing Program for chez
;
;    original program by Ryoji Kawamichi
;            arranged by Motohico Nanano
;
;               Solver.scm
;
;         last change : 1996/4/8
;-----------------------------------------------------------------------------

; $BD>@~$H%*%V%8%'%/%H$N8rE@$r5a$a$k4X?t72(B
;
; solver <-$B30It$+$i8F$S=P$5$l$k!#(B
;
; Solver-Rect
; Solver-Surface
; Solver-Second
;


;----------------------------------------------------------------------------
; solver : $BD>@~(B $B#L#t!\#P$H!"%*%V%8%'%/%H$H$N8rE@$r5a$a$k!#(B
;     index : $B%*%V%8%'%/%H$N(B No.
;       L,P : $B%Y%/%H%k(B
;    return : (cons  $B8rE@$,$"$k$+!)(B  $B8rE@$,$"$C$?;~$N#t$NCM(B)
;----------------------------------------------------------------------------

(define (solver index L P)
  (let* ((m (vector-ref object index))
	 (Wx (- (vector-ref P 0) (vector-ref m 7)))
	 (Wy (- (vector-ref P 1) (vector-ref m 8)))
	 (Wz (- (vector-ref P 2) (vector-ref m 9))))
    ;solver $BK\BN(B 
    ;$B%*%V%8%'%/%H$N7A$K$h$C$F>l9gJ,$1(B
    (let ((r (let ((Form_m (vector-ref m 1)))
	       (cond 
		((= Form_m 1) (Solver-Rect m Wx Wy Wz L))
		((= Form_m 2) (Solver-Surface m Wx Wy Wz L))
		(else    (Solver-Second m Wx Wy Wz L))))))
      r))
)

;--------------------------------------------------------------------
; $B4X?t(B Solver-Rect $BD>J}BN%*%V%8%'%/%H$HD>@~$H$N8rE@$r5a$a$k!#(B
;--------------------------------------------------------------------
(define (Solver-Rect m Wx Wy Wz L)
  
  (let* ((L0  (vector-ref L 0))
	 (L1  (vector-ref L 1))
	 (L2  (vector-ref L 2))
	 (msg (vector-ref m 10))
	 (ma  (vector-ref m 4))
	 (mb  (vector-ref m 5))
	 (mc  (vector-ref m 6))
	
  ;$B%5%$%I#A$K$D$$$F8rE@$,$"$k$+$rD4$Y$k(B
	 (answerA 
	  (let ((sign (sgn (* L0 msg))))
	    (if (f!= sign 0.0)
		(let ((answer0 
		       (- (/ (+ Wx (* sign ma)) L0))))
		  (if (and (<= (abs (+ (* answer0 L1) Wy))mb)
			   (<= (abs (+ (* answer0 L2) Wz))mc))
		      answer0
		      #f))
		#f))))

    (if answerA
	(begin 
	  ;$B%5%$%I#A$K$V$D$+$C$?$3$H$r%*%V%8%'%/%H$K=q$-9~$`(B
	  ;m19=Rectside=1
	  (vector-set! m 19 1)
	  answerA)

	;$B%5%$%I(BA$B$K$V$D$+$i$J$$;~$K$O!"%5%$%I#B$K$D$$$F8rE@$rD4$Y$k(B
	(let ((answerB 
	       (let ((sign (sgn (* L1 msg))))
		 (if (f!= sign 0.0)
		     (let ((answer1 
			    (- (/ (+ Wy (* sign mb)) L1))))
		       (if (and 
			    (<= (abs (+ (* answer1 L2) Wz))mc)
			    (<= (abs (+ (* answer1 L0) Wx))ma))
			   answer1
			   #f))
		     #f))))
	       
	  (if answerB
              (begin 
		;$B%5%$%I#B$K$V$D$+$C$?$3$H$r%*%V%8%'%/%H$K=q$-9~$`(B
		;m19=Rectside
		(vector-set! m 19 2)
		answerB)

	      ;$B%5%$%I#C$K$D$$$F8rE@$rD4$Y$k(B
	      (let ((answerC 
		     (let ((sign (sgn (* L2 msg))))
		       (if (f!= sign 0.0)
			   (let ((answer2 
				  (- (/ (+ Wz (* sign mc)) 
					  L2))))
			     (if (and
				  (<= (abs (+ (* answer2 L0) 
						 Wx))ma)
				  (<= (abs (+ (* answer2 L1)
						 Wy))mb))
				 answer2
				 #f))
			   #f))))
		
		(if answerC
		     (begin 
		       ;$B%5%$%I#C$K$V$D$+$C$?$3$H$r%*%V%8%'%/%H$K=q$-9~$`(B
		       (vector-set! m 19 3)
		       answerC)
		     #f)))))))

;--------------------------------------------------------------------
; $BJ?LL%*%V%8%'%/%H$HD>@~$H$N8rE@$r5a$a$k!#(B
;--------------------------------------------------------------------

(define (Solver-Surface m Wx Wy Wz L)
  ;m10=$B6K@-(B
  (let* ((msg (vector-ref m 10))
	 (ma  (vector-ref m 4))
	 (mb  (vector-ref m 5))
	 (mc  (vector-ref m 6))
	 (q (- (* msg 
		    (+ (* (vector-ref L 0) ma) 
			(* (vector-ref L 1) mb) 
			(* (vector-ref L 2) mc))))))
    (if (> q 0.0)
	(/ (* msg (+ (* Wx ma) 
			(* Wy mb) 
			(* Wz mc))) q)
	#f)))

;--------------------------------------------------------------------
; $B#2<!6JLL%*%V%8%'%/%H$HD>@~$H$N8rE@$r5a$a$k!#(B
;--------------------------------------------------------------------

(define (Solver-Second m Wx Wy Wz L)
  ; t$B$N#2<!J}Dx<0$K$J$C$?;~$N(B
  ;   aa:t^2$B$N78?t(B  bb:t$B$N78?t(B  cc:$BDj?t9`(B
  
  (let* ((Lx  (vector-ref L 0))
	 (Ly  (vector-ref L 1))
	 (Lz  (vector-ref L 2))
	 (rt? (vector-ref m 3))
	 (ma  (vector-ref m 4))
	 (mb  (vector-ref m 5))
	 (mc  (vector-ref m 6))
    
	 (aa0 (+ (* (fsqr Lx) ma) 
		  (* (fsqr Ly) mb) 
		  (* (fsqr Lz) mc)))
	 
	 ;m3=$B2sE>!)(B
	 (aa (begin 
		    (if rt?
			(+ aa0 
			    (* Ly Lz (vector-ref m 16))
			    (* Lx Lz (vector-ref m 17))
			    (* Lx Ly (vector-ref m 18)))
			aa0))))
    ;(write aa)
    (if (= aa 0.0)
	(begin ;(write aa)
	  #f)
	(let* ((bb0 (* 2.0 (+ (* Wx Lx ma)(* Wy Ly mb)
				(* Wz Lz mc))))
	      
	       ;m3=$B2sE>!)(B
	       (bb (if rt?
		       (+ bb0 
			   (* (+ (* Wz Ly) (* Wy Lz))
                               (vector-ref m 16))
			   (* (+ (* Wx Lz) (* Wz Lx))
                               (vector-ref m 17))
			   (* (+ (* Wx Ly) (* Wy Lx))
                               (vector-ref m 18)))
		       bb0))
	       
	       (cc0 (+ (* (fsqr Wx) ma) 
                        (* (fsqr Wy) mb) 
                        (* (fsqr Wz) mc)))
	       
	       ;m3=$B2sE>!)(B
	       (cc1 (if rt?
			(+ cc0 
			    (* Wy Wz (vector-ref m 16)) 
                            (* Wx Wz (vector-ref m 17)) 
                            (* Wx Wy (vector-ref m 18)))
			cc0))
	       (cc (if (= (vector-ref m 1) 3) (- cc1 1.0) cc1)) 
	       
	       ; $BH=JL<0(B
	       (D  (- (fsqr bb) (* 4.0 aa cc))))
	  (begin  ;(write D)(newline)
	    (if (>= D 0.0)
		(/ (- (* (- (vector-ref m 10)) (sqrt D)) bb) 2.0 aa)
		#f))))))
;$B1F$r%A%'%C%/$9$k4X?t(B
;(load "Shadow.scm")
;-----------------------------------------------------------------------------
;       Ray Tracing Program for chez
;
;    original program by Ryoji Kawamichi
;            arranged by Motohico Nanano
;
;               Shadow.scm
;
;         last change : 1996/4/8
;-----------------------------------------------------------------------------

; $B1F$NM-L5$rD4$Y$k4X?t72(B
;
; Shadow-Check-One-Or-Group <-$B30It$+$i8F$S=P$5$l$k!#(B
;
; Shadow-Check-One-Or-Matrix
; Shadow-Check-And-Group

;  $BD4$Y$?$$E@#P$+$i!"8w@~%Y%/%H%k$NJ}8~$K$?$I$C$F$$$C(B
;    $B$F!"J*BN$,$"$k$+$I$&$+$rD4$Y$k!#8rE@$,$"$l$P(B $BE@(BP$B$O$=$NJ*BN$N1F(B
;$B$K$"$k!#$h$C$F(B #t $B$rJV$9!#(B
;   $B$9$Y$F$NJ*BN$K$D$$$FD4$Y1F$K$J$C$F$$$J$1$l$P(B false$B$rJV$9!#(B
;      $B$D$^$j!"E@#P$,1F$+1F$G$J$$$+$rJV$9!#(B


;-------------------------------------------------------------------
;or $B%^%H%j%C%/%9$N#1$D$N9T$K$D$$$F!"8rE@$,$"$k$+D4$Y$k!#(B
;-------------------------------------------------------------------

(define (Shadow-Check-One-Or-Matrix or-matrix P)

  ;null = $BA4$F$N%*%V%8%'%/%H$rD4$Y$F(BP$B$+$i8w8;$N4V$KJ*BN$O$J$$!#(B
  ; $B$D$^$j(B $BE@(BP $B$O(B $B1F$G$J$$!#(B= false
  (if (null? or-matrix)
      #f

      ;$B3F(BOR-group$B$K4X$7$F$N%A%'%C%/(B

      ;$B$^$:!"%l%s%8%W%j%_%F%#%V$,$"$k$+D4$Y$k!#(B
      (let* ((range-primitive (caar or-matrix)))

        ;$B%l%s%8%W%j%_%F%#%V$,B8:_$9$k$J$i!"$=$l$K$V$D$+$k$+$I$&$+$r(B
	;$BD4$Y$k!#%l%s%8%W%j%_%F%#%V$K$V$D$+$i$J$$$H$$$&$3$H$O!"$=$N(B
	;or-group$B$NA4$F$NMWAG$H$V$D$+$i$J$$$H$$$&;v$G$"$k!#(B
        (if (= range-primitive 99)

	    ;$B%l%s%8%W%j%_%F%#%V$,B8:_$7$J$$;~(B
	    ;$B$^$:!"$=$N(Bor-group$B$rD4$Y$k!#!J(B99$B$O%9%-%C%W!K(B
	    (if (Shadow-Check-One-Or-Group (cdar or-matrix) P)
		;$B$V$D$+$C$?$i1F(B = #t $B$G=*N;(B
		#t
		;$B$V$D$+$i$J$+$C$?$i<!$N(B or-group$B$rD4$Y$k!#(B
		(Shadow-Check-One-Or-Matrix (cdr or-matrix) P))

	    ;$B%l%s%8%W%j%_%F%#%V$,B8:_$9$k;~(B
	    (let ((t (solver range-primitive Light P)))
	      
	      ;$B%l%s%8%W%j%_%F%#%V$K$V$D$+$C$?$i(B
	      (if (and t (< t -0.1)) 
		  
		  ;$B%l%s%8%W%j%_%F%#%V0J30$NA4MWAG$N$I$l$+$H$V$D$+$k(B
		  ;$B$+$r%A%'%C%/!#(B
		  (if (Shadow-Check-One-Or-Group (cdar or-matrix) P)
		      ;$B$V$D$+$C$?$i1F(B = #t $B$G=*N;(B
		      #t
		      ;$B$V$D$+$i$J$+$C$?$i<!$N(B or-group$B$rD4$Y$k!#(B
		      (Shadow-Check-One-Or-Matrix (cdr or-matrix) P))
		  ;$B%l%s%8%W%j%_%F%#%V$K$V$D$+$i$J$+$C$?$i<!$N(Bor-gro
		  ;up$B$rD4$Y$k!#(B
		  (Shadow-Check-One-Or-Matrix (cdr or-matrix) P)))

	    ))))

;-------------------------------------------------------------------
; or $B%^%H%j%C%/%9$N#1$D$N9T!J%l%s%8%W%j%_%F%#%V$r=|$/!K(B or-group $B$N(B
;$BMWAG$=$l$>$l$K$D$$$F!"8rE@$,$"$k$+D4$Y$k!#$"$C$?$i!"$=$N;~E@$G(B #t 
;$B$rJV$9!#(B
;-------------------------------------------------------------------

(define (Shadow-Check-One-Or-Group or-group P)
  
  ;or-group$B$NA4MWAG$rD4$Y$?!#!a$=$N(Bor-group$B$K4X$7$F$O1F$G$O$J$$!#(B
  (if (null? or-group)
      #f

      ;or-group$B$NMWAG$N(B and-group$B$r<h$j$@$7!"3FJ*BN$K$D$$$FD4$Y$k!#(B
      (let* ((and-group (vector-ref and-Net (car or-group)))
	     (Shadow?   (Shadow-Check-And-Group and-group and-group P)))
	(if Shadow?
	    #t
	    ;$B$=$N(Band-group$B$K1F$,$J$1$l$P<!$N(Band-group$B$rD4$Y$k!#(B
	    (Shadow-Check-One-Or-Group (cdr or-group) P)))))
;-------------------------------------------------------------------
; and-group $B$NA4MWAG$KBP$7!"$=$l$>$l8rE@$,$"$k$+$I$&$+$rD4$Y$k!#$?$@(B
;$B$7!":#EY$O8rE@$N:BI8$O5a$a$J$$!#(B
;-------------------------------------------------------------------

(define (Shadow-Check-And-Group iand and-group P)

  (if (null? iand)
      ;$B$=$N(Band-group$B$NA4J*BN$K$D$$$F1F$G$O$J$$!#(B
      #f
      
      ;and-group$B$N$"$kJ*BN(Bobj $B$H(B $BE@(BP$B$+$i$N8w8;J}8~$,8rE@$r$b$D$+!)(B
      (let* ((obj (car iand))
	     (t0 (solver obj Light P)))
	  
	;$BJ*BN$H8rE@$,$"$k$+!)(B
	(if (and t0 (>= -0.2 t0))
	    
	    ;Q = $B8rE@$N:BI8(B
	    (let* ((t  (+ t0 0.01))
		   (Qx (+ (* (vector-ref Light 0) t)
			   (vector-ref P 0)))
		   (Qy (+ (* (vector-ref Light 1) t) 
			   (vector-ref P 1)))
		   (Qz (+ (* (vector-ref Light 2) t) 
			   (vector-ref P 2))))

	      ;and-group$B$NE@$G$"$k$H$$$&$3$H$O!"(Bgroup$BFb$NA4$F$N(Bobject
	      ;$B$N6&DLItJ,$H$N8rE@$G$"$k$H$$$&$3$H$G$"$j!"(Bgroup$BFb$NA4(B
	      ;$B$F$N(Bobject$B$,$=$N8rE@$r4^$`$^$?$O>e$K;}$DI,MW$,$"$k!#(B
	      (or (Check-All-Inside Qx Qy Qz and-group)
		  ;$B6&DLItJ,$r$N8rE@$rC5$9$?$a<!$NJ*BN$rD4$Y$k!#(B
		  (Shadow-Check-And-Group (cdr iand) and-group P)))
	    
	    ;$B8rE@$,$J$$;~!"$=$NJ*BN$OFbB&$,??$J$i(Band-group$B$K$h$kJ*BN(B
	    ;$B$O$3$NJ*BN$N$J$+$K$"$k$?$a!"$[$+$NJ*BN$H$N8rE@$rD4$Y$kI,(B
	    ;$BMW$O$J$$!#$D$^$j!"$3$N(Band-group$B$N1F$G$O$J$$!#(B
	    (if (> (vector-ref (vector-ref object obj) 10) 0.0)
		#f 
		(Shadow-Check-And-Group (cdr iand) and-group P))))))


;$B%5%V%k!<%A%s(B
;(load "Subroutine.scm")
;;----------------------------------------------------------------------------
;       Ray Tracing Program for chez
;
;    original program by Ryoji Kawamichi
;            arranged by Motohico Nanano
;
;               Subroutine.scm
;
;         last change : 1996/4/8
;-----------------------------------------------------------------------------

; Get-Nvector
; Check-All-Inside
; utexture

;(define floor floor)  ; $B%@%_!<Dj5A!#$"$H$G4X?t$r%5%]!<%H$9$k(B

;-----------------------------------------------------------------------------
; Get-NVector : 
;       $B%*%V%8%'%/%H(Bm$B$NE@#P$K$*$1$kK!@~%Y%/%H%k$r5a$a(B,NVector$B$XJV$9!#(B
;-----------------------------------------------------------------------------

(define NVector (make-vector 3))

(define (Get-NVector m Vscan P)
  (begin

    ;Form = object$B$N7A(B
    (let ((Form (vector-ref m 1)))

      (cond 

       ;$BD>J}BN$N;~(B
       ((= Form 1)
	(let ((RectSide (vector-ref m 19)))

	  ;$BE@(BP$B$O$I$NLL>e$K$"$k$+!#(B
	  (cond 
	   ((= RectSide 1)
	    (begin
	      (vector-set! NVector 0 (- (sgn (vector-ref Vscan 0))))
	      (vector-set! NVector 1 0.0)
	      (vector-set! NVector 2 0.0)))
	    
	   ((= RectSide 2)
	    (begin 
	      (vector-set! NVector 0 0.0)
	      (vector-set! NVector 1 (- (sgn (vector-ref Vscan 1))))
	      (vector-set! NVector 2 0.0)))

	   ((= RectSide 3)
	    (begin
	      (vector-set! NVector 0 0.0)
	      (vector-set! NVector 1 0.0)
	      (vector-set! NVector 2 (- (sgn (vector-ref Vscan 2)))))))))
	    
       ;$BJ?LL$N;~(B
       ((= Form 2)
	(begin
	  (vector-set! NVector 0 (* (vector-ref m 10)

				     (vector-ref m 4)))
	  (vector-set! NVector 1 (* (vector-ref m 10)
				     (vector-ref m 5)))
	  (vector-set! NVector 2 (* (vector-ref m 10)
				     (vector-ref m 6)))))
	    
       ;$BFs<!6JLL$^$?$O?mBN$N;~(B
       (else 

	(if (vector-ref m 3) 
	    
	    ;$B2sE>$7$F$$$k;~(B
	    (let* ((w1 (- (vector-ref P 0) (vector-ref m 7)))
		   (w2 (- (vector-ref P 1) (vector-ref m 8)))
		   (w3 (- (vector-ref P 2) (vector-ref m 9)))
		   (nx (+ (* w1 (vector-ref m 4)) 
			   (* 0.5 (+ (* w2 (vector-ref m 18)) 
				       (* w3 (vector-ref m 17))))))
		   (ny (+ (* w2 (vector-ref m 5)) 
			   (* 0.5 (+ (* w1 (vector-ref m 18)) 
				       (* w3 (vector-ref m 16))))))
		   (nz (+ (* w3 (vector-ref m 6)) 
			   (* 0.5 (+ (* w1 (vector-ref m 17)) 
				       (* w2 (vector-ref m 16))))))
		   (n0 (* (sqrt (+ (fsqr nx) (fsqr ny) (fsqr nz)))
			   (vector-ref m 10)))
		   (n (if (= n0 0.0) 1.0 n0)))
	      (begin
		(vector-set! NVector 0 (/ nx n))
		(vector-set! NVector 1 (/ ny n))
		(vector-set! NVector 2 (/ nz n))))

	    ;$B2sE>$,$J$$;~(B
	    (let* ((nx (* (- (vector-ref P 0) (vector-ref m 7)) 
			   (vector-ref m 4)))
		   (ny (* (- (vector-ref P 1) (vector-ref m 8)) 
			   (vector-ref m 5)))
		   (nz (* (- (vector-ref P 2) (vector-ref m 9)) 
			   (vector-ref m 6)))
		   (n0 (* (sqrt (+ (fsqr nx) (fsqr ny) (fsqr nz))) 
			   (vector-ref m 10)))
		   (n  (if (= n0 0.0) 1.0 n0)))
	      (begin
		(vector-set! NVector 0 (/ nx n))
		(vector-set! NVector 1 (/ ny n))
		(vector-set! NVector 2 (/ nz n))))))))    
    NVector))


;-------------------------------------------------------------------
; and-group$B$K4^$^$l$kA4%*%V%8%'%/%H$NFbIt$^$?$O>e$KE@(BQ$B$,B8:_$9$k$+!#(B
;-------------------------------------------------------------------

(define (Check-All-Inside Qx Qy Qz iand)
  ;$BA4$F$NJ*BN$,(BQ$B$r4^$s$@$i(B#t
  (or (null? iand)
      
      ;$BE@(Bp$B$,J*BN(Bm$B$NFbB&$+(B(1),$B$=$N>e$+(B(0)$B$J$i$P<!$NJ*BN$r%A%'%C%/(B
      (if (>= (inout (vector-ref object (car iand)) Qx Qy Qz) 0.0)
	  (Check-All-Inside Qx Qy Qz (cdr iand))
	  #f)))

;--------------------------------------------------------------------
; Inout : $BE@#P$,J*BN#m$N30B&$+!J!]#1!K!"FbB&$+!J#1!K!"$=$N>e$+!J#0!K(B
;         $B$rJV$94X?t(B
;--------------------------------------------------------------------

(define (inout m Px Py Pz)
  (let ((Qx (- Px (vector-ref m 7)))
	(Qy (- Py (vector-ref m 8)))
	(Qz (- Pz (vector-ref m 9)))
	(Form (vector-ref m 1)))
    ;$BJ*BN$N<oN`$K$h$kJ,4t(B
    (cond 

     ;$BD>J}BN(B
     ((= Form 1) 
      (if (and (<= (abs Qx) (vector-ref m 4)) 
	       (<= (abs Qy) (vector-ref m 5)) 
	       (<= (abs Qz) (vector-ref m 6)))
	  (vector-ref m 10)
	  (- (vector-ref m 10)))) ;return
     
     ;$BJ?LL(B
     ((= Form 2)
      (- (* (vector-ref m 10) 
		 (sgn (+ (* (vector-ref m 4) Qx) 
			  (* (vector-ref m 5) Qy) 
			  (* (vector-ref m 6) Qz)))))) ;return
     
     ;$BFs<!6JLL(B
     ((= Form 3)
      (let ((temp (+ (* (fsqr Qx) (vector-ref m 4)) 
		      (* (fsqr Qy) (vector-ref m 5)) 
		      (* (fsqr Qz) (vector-ref m 6)) -1.0)))
	;m3=$B2sE>!)(B
	(if (vector-ref m 3)
	    (- (* (vector-ref m 10)
		       (sgn (+ temp
				(* Qy Qz (vector-ref m 16))
				(* Qx Qz (vector-ref m 17))
				(* Qx Qy (vector-ref m 18))))));return
	    (- (* (vector-ref m 10)(sgn temp)))))) ;return
     
     ;$B?mBN(B
     ((= Form 4)
      (let ((temp (+ (* (fsqr Qx) (vector-ref m 4)) 
		      (* (fsqr Qy) (vector-ref m 5)) 
		      (* (fsqr Qz) (vector-ref m 6)))))
	;m3=$B2sE>!)(B
	(if (vector-ref m 3)
	    (- (* (vector-ref m 10)
		       (sgn (+ temp
				(* Qy Qz (vector-ref m 16))
				(* Qx Qz (vector-ref m 17))
				(* Qx Qy (vector-ref m 18))))));return
	    (- (* (vector-ref m 10)(sgn temp))))))         ;return
     )))

;*********************************************************************
; utexture : $B%f!<%6!<Dj5A%F%/%9%A%e%"$K=>$C$F?'$rJQ99$9$k4X?t(B
;*********************************************************************
(define (utexture m P)
  (let ((Texture (vector-ref m 0)))

    (cond 

     ;tile
     ((= Texture 1)
      
      ;w = offset$B$r$H$C$?$H$-$N(Bx,$B:BI8(B
      (let* ((w1    (- (vector-ref P 0) (vector-ref m 7)))
	     (w3    (- (vector-ref P 2) (vector-ref m 9)))

	     ;$B:BI8(B20$B$4$H$K?'$rJQ$($k!#(B
	     (flag1 (> (- w1 (* (floor (* w1 0.05)) 20.0)) 10.0))
	     (flag2 (> (- w3 (* (floor (* w3 0.05)) 20.0)) 10.0)))
	;G=255 or G=0$B$G$A$'$C$/$b$h$&$K$9$k!#(B
	(vector-set! m 14 
		     (if flag1 
			 (if flag2 255.0 0.0)
			 (if flag2 0.0 255.0)))))

     ;stripe     
     ((= Texture 2)
      (let ((w2 (fsqr (sin (* (vector-ref P 1) 0.25))))
	    (w3 (fsqr (cos (* (vector-ref P 1) 0.25)))))
	(begin 
	  ;R=255*w2 G=255*w3
	  (vector-set! m 13 (* 255.0 w2))
	  (vector-set! m 14 (* 255.0 w3)))))
     
     ;ring     
     ((= Texture 3)
      (let* ((w1 (- (vector-ref P 0) (vector-ref m 7)))
	     (w3 (- (vector-ref P 2) (vector-ref m 9)))
	     (w2 (/ (sqrt (+ (fsqr w1) (fsqr w3))) 10.0))
	     (w4 (* 3.1415927 (- w2 (floor w2))))
	     (cw (cos w4))
	     (sw (sin w4)))
	(begin
	  (vector-set! m 14 (* (fsqr cw) 255.0))
	  (vector-set! m 15 (* (fsqr sw) 255.0)))))
             
     ;dot
     ((= Texture 4)  ;dot
      (let* ((w1 (* (- (vector-ref P 0) (vector-ref m 7)) 
		     (sqrt (vector-ref m 4))))
	     (w2 (* (- (vector-ref P 1) (vector-ref m 8)) 
		     (sqrt (vector-ref m 5))))
	     (w3 (* (- (vector-ref P 2) (vector-ref m 9)) 
		     (sqrt (vector-ref m 6))))
	     (w4 (+ (fsqr w1) (fsqr w3)))
	     (w5 (if (> (abs w1) 0.0001)
		     (abs (/ w3 w1))
		     1.0e15))
	     (w6 (if (> (abs w4) 0.0001)
		     (abs (/ w2 w4))
		     1.0e15))
	     (w7 (/ (* (atan w5) 30.0) 3.1415927))
	     (w8 (/ (* (atan w6) 30.0) 3.1415927))
	     (w9  (- w7 (floor w7)))
	     (w10 (- w8 (floor w8)))
	     (w11 (- 0.15 (fsqr (- 0.5 w9)) (fsqr (- 0.5 w10))))
	     (w12 (if (< w11 0.0) 0.0 w11)))
	(vector-set! m 15 (/ (* 256.0 w12) 0.3))))

     ;new_tile
     ((= Texture 5)
      
      ;w = offset$B$r$H$C$?$H$-$N(Bx,z$B$6$R$g$&(B
      (let* ((w1    (- (vector-ref P 0) (vector-ref m 7)))
	     (w2    (- (vector-ref P 1) (vector-ref m 8)))
	     (w3    (- (vector-ref P 2) (vector-ref m 9)))

	     ;$B$6$R$g$&(B20$B$4$H$K$$$m$r$+$($k!#(B
	     (flag1 (> (- w1 (* (floor (* w1 0.05)) 20.0)) 10.0))
	     (flag2 (if (> (- w2 (* (floor (* w2 0.05)) 20.0)) 10.0)
			(not flag1)
			flag1))
	     (flag3 (if (> (- w3 (* (floor (* w3 0.05)) 20.0)) 10.0)
			(not flag2)
			flag2)))
	
	;G=255 or G=0$B$G$A$'$C$/$b$h$&$K$9$k!#(B
	(vector-set! m 14 
		     (if flag3 0.0 255.0))))
     ) ; end case
    ))





;-------------------------------------------------------------------
;  rt : $B%a%$%s4X?t(B
;
;  $B!&(B $B<B9T;~$N%Q%i%a!<%?$N3JG<!#(B
;  $B!&(B $B%G!<%?$rFI$_9~$`(B
;  $B!&(B $B%9%/%j!<%s$N3FE@$K$D$$$F%l%$%H%l!<%9$9$k!#(B
;  $B$H$$$C$?A`:n$r9T$J$&!#(B
;
;  InputFileName  : $B%U%)!<%^%C%H$K$7$?$,$C$?F~NO%G!<%?(B
;  OutputFileName : $B=PNO%U%!%$%kL>(B
;  size-x         : x$B<4J}8~$NAv::@~K\?t(B
;  size-y         : y$B<4J}8~$NAv::@~K\?t(B
;  Debug?         : $B:#!"(By$B<4J}8~$NAv::@~$N2?K\L\$rD4$Y$F$$$k$+I=<($9$k$+!)(B
;  Shadow?        : $B1F$r$D$1$k$+!)(B
;-------------------------------------------------------------------
(define (showlst lst)
  (if (null? lst)
      '()
      (begin (write (car lst))(newline)
	     (showlst (cdr lst)))))

(define (showornet ornet)
  (if (null? ornet)
      '()
      (begin (showlst (car ornet))
	     (showornet (cdr ornet)))))
(define (showornet2 ornet)
  (if (null? ornet)
      '()
      (begin (showornet (car ornet))
	     (showornet2 (cdr ornet)))))

(define (rt InputFileName OutputFileName size-x size-y Debug? Shadow?)
  (begin

    ;CompilerCheck.scm$B$N;HMQ;~$N$_!"3F?t$N=i4|2=(B
    ;(SetN)
    
    ;object$B$NG[Ns$NMQ0U(B
    (set-object 0)
    
    ;$B<B9T;~%Q%i%a!<%?$NFI$_9~$_(B
    (set-car! size size-x)
    (set-cdr! size size-y)
    (set-car! dbg Debug?)
    (set-car! sh Shadow?)
    
    ;$B%G!<%?$NFI$_9~$_(B
    (Read-Parameter InputFileName)
    ;(showornet2 or-Net)
    ;(write or-Net)
    ;$B%l%$%H%l!<%9$9$k!#(B
    (Scan-Start OutputFileName)
    ))
;$BF~NO%U%!%$%k(B
(define in "contest.sld")
;$B=PNO%U%!%$%k(B  : xv$B$G8+$l$k!#(B
(define out "q5.ppm")
;load$B;~$K<+F0E*$K<B9T$9$k!#(B
(begin
  (rt in out 20 20 #f #t)
  (display out)
  )

