%{
(* $BJd=uE*$JJQ?t!"4X?t!"7?$J$I$NDj5A(B *)
open PreSyntax
open Library
open Interp 

exception Parse_error

let debug str = () (* print_endline ("paser : "^ str) *)


%}

/* syntactic keyword */
%token ELSE RIGHTARROW DEFINE UNQUOTE UNQUOTE_SPLICING
/* syntactic_keyword - expressioin keyword */
%token QUOTE LAMBDA IF SET BEGIN COND AND OR CASE LET LETSTAR LETREC DO DELAY QUASIQUOTE LET_SYNTAX LETREC_SYNTAX DEFINE_SYNTAX SYNTAX_RULES

/* token */
%token LPAREN RPAREN SHARP_LPAREN S_QUOTE S_UNQUOTE S_COMMA S_COMMA_ATMARK DOT 
/* end_of_file */
%token EOF


%token <Library.scmnum> NUMBER
%token <bool>   BOOLEAN
%token <string> VARIABLE
%token <char>   CHARACTER
%token <string> STRING

%type <Interp.scmval> datum
%start datum

%%
datum:
| simple_datum
    { $1 }
| compound_datum
    { $1 }
;
simple_datum:
| BOOLEAN 
    { VBool $1 }
| NUMBER
    { VNum ($1,read_get_reg ()) }
| CHARACTER
    { VChar($1,read_get_reg ())  }
| STRING
    { VString($1,read_get_reg ())  }
| symbol
    { VSymbol($1,read_get_reg ())  }
;
symbol:
| VARIABLE
    { $1 }
;
compound_datum:
| list
    { $1 }
| vector
    { $1 }
;
list:
| LPAREN datum_list RPAREN
    { List.fold_right (fun x p -> VPair({car=x;cdr=p},read_get_reg ())) $2 VNill }
| LPAREN datum datum_list DOT datum RPAREN
    { failwith "not implemented list " }
| abbreviation
    { failwith "not implemented list" }
;
abbreviation:
| QUOTE datum
    { failwith "not implemented quote" }
| UNQUOTE datum
    { failwith "not implemented unquote" }
| S_COMMA datum
    { failwith "not implemented scomma" }
| S_COMMA_ATMARK datum
    { failwith "not implemented scomma atmark" }
;
vector:
| SHARP_LPAREN datum_list RPAREN
    { VVector(Array.of_list $2, read_get_reg ()) }
;
datum_list:
| datum datum_list
    { $1::$2 }
| 
    { [] }
