(** ꡼ȡ꡼Ĥȡե*)
(* $Id: rtype.ml,v 1.28 2003/10/11 15:48:50 ganat Exp $ *)

open Mylist

(* ---------------------- *)

(** Id *)
type id = string

(** ꡼ *)
type region = int

let string_of_reg r = "r" ^ (string_of_int r)
let  global_reg  = -1
(** եѿ *)
type effvar = id

(** ȥߥåե *)
type atmEff = 
    Reg of region 
  | Eff of effvar 

(** ե *)
type effect = atmEff list

let rec divide_effect e =
  match e with
    Reg(r)::tl -> let (a,b) = divide_effect tl in (r::a,b)
  | Eff(f)::tl -> let (a,b) = divide_effect tl in (a,f::b)
  | [] -> ([],[])

(** latentե *)
type latentEffect = effvar * effect

(** ꡼Ĥ  *)
type rtype = 
    { label:id; (* դ *) 
      slabel:  id; (* stype  *)
      num:region option; 
      bool:bool; 
      char:region option;
      port:region option;
      string:region option;
      symbol:region option;
      null: bool;
      mutable func: ((rtype list * rtype)* latentEffect * rtype * region) option;
      mutable pair: (rtype * rtype * region) option;
      mutable vector: (rtype * region) option;
    }
(** ꡼ *)
module Rsubst = 
  Map.Make( 
    struct 
      type t = region
      let compare = compare
    end)

let rsubst_append x y = Rsubst.fold Rsubst.add x y
  
let list_map_to_rsubst map = List.fold_right (fun (x,y) t -> Rsubst.add x y t) map Rsubst.empty 

type substRegion = region Rsubst.t (* (region * region) list *)

(** եѿ *)
type substEffect = (effvar * latentEffect) list

(** ꡼󤬴Ϣ *)
type rsubst = substRegion * substEffect

(** ꡼¿ؿ˥꡼ȤŬѤΥե *)
type regpolEff = region list

(**  *)
type rtype_scheme = 
    Forall of region list * regpolEff * effvar list *  rtype * region
  | Normal of rtype 

(** Ķ *)
type rtype_env = (string * rtype_scheme) list

(* --------- ˻Ȥؿ ---------------------------------------------- *)

(* ٥ *)
let newlabel = 
  let n = ref 0 in 
  function () -> n := !n + 1 ; "rt" ^ (string_of_int !n)


(** atomic effect ʸɽ *)
let string_of_atmEff = function 
    Reg(r) -> "r" ^ (string_of_int r)
  | Eff(e) -> e

(** latent effect ʸɽ *)
let string_of_ltntEff (e,ef) = 
  e ^ (List.fold_right (^) (List.map string_of_atmEff ef) "")
	
(** rsubst ʸɽ *)
let string_of_rsubst ((sr,se):rsubst) : string =
  (Rsubst.fold (fun key v str -> (string_of_reg key) ^ "->" ^ (string_of_reg v) ^ str) sr "") 
  (* List.fold_right (^) (List.map (function (x,y) -> "(r"^(string_of_int x)^"->r"^(string_of_int y)^")") sr) "" *)
  ^ (List.fold_right (^) 
       (List.map (function (x,y) -> "("^x^"->"^(string_of_ltntEff y)^")") se) "")

(** rtype ʸɽ *)
let string_of_rtype (rt:rtype) : string = 
  let rec iter donelst rt =
    if(List.mem rt.label donelst)
    then 
      rt.label
    else
      begin 
	("(" ^ rt.label^".") ^ 
	(match rt.num with Some(r) -> "num," ^ (string_of_reg r) | None -> "") ^
	(if(rt.bool) then "bool" else "") ^
	(match rt.char with Some(r) -> "char," ^ (string_of_reg r) | None -> "") ^
	(match rt.port with Some(r) -> "port," ^  (string_of_reg r) | None -> "") ^
	(match rt.string with Some(r) -> "string," ^  (string_of_reg r) | None -> "") ^
	(match rt.symbol with Some(r) -> "symbol," ^  (string_of_reg r) | None -> "") ^
	(if(rt.null) then "null" else "") ^
	begin 
	  match rt.func with
	    Some((rf,tail),le,rr,reg) -> 
	      (List.fold_right (^) (List.map (iter (rt.label::donelst)) rf) "")
	      ^ " . " ^ (iter (rt.label::donelst) tail)
	      ^ "->" 
	      ^ "{" ^ (string_of_ltntEff le) ^ "}"
	      ^ (iter (rt.label::donelst) rr)
	      ^ "," ^  (string_of_reg reg)
	  | None -> ""
	end ^ 
	begin 
	  match rt.pair with
	    Some(l,r,reg) -> 
	      (iter (rt.label::donelst) l)
	      ^ "*" ^
	      (iter (rt.label::donelst) r)
	      ^ "," ^  (string_of_reg reg)
	  | None -> ""
	end ^
	begin 
	  match rt.vector with
	    Some(v,reg) -> 
	      "#" ^ 
	      (iter (rt.label::donelst) v)
	      ^ "," ^  (string_of_reg reg)
	  | None -> ""
	end ^
	")"
      end
  in iter [] rt


let rtype_car_of_pair t = 
  match t.pair with Some(car,_,_) -> car 
  | None -> failwith "Rtpe.rthype_car_of_pair : invalid argument"

(** rtype  stypeѴ *)
let rtype_to_stype (rt:rtype) :Stype.stype = 
  let rec iter donelst rt = 
    if (List.mem_assoc rt.label donelst)
    then List.assoc rt.label donelst 
    else 
      let sttmp = 
	{ Stype.label = rt.slabel;
	  Stype.num = 
	  (match rt.num with Some _ -> true | None -> false);
	  Stype.bool = rt.bool;
	  Stype.char =
	  (match rt.char with Some _ -> true | None -> false);
	  Stype.port =
	  (match rt.port with Some _ -> true | None -> false);
	  Stype.string =
	  (match rt.string with Some _ -> true | None -> false);
	  Stype.symbol =
	  (match rt.symbol with Some _ -> true | None -> false);
	  Stype.null = rt.null;
	  Stype.func = None;
	  Stype.pair = None;
	  Stype.vector = None
	} 
      in 
      let f = 
	match rt.func with
	  Some((args,tail),_,ret,_) ->
	    Some((List.map (iter ((rt.label,sttmp)::donelst)) args,
		  iter ((rt.label,sttmp)::donelst) tail),
		 iter ((rt.label,sttmp)::donelst) ret)
	| None -> None
      in 
      let p = 
	match rt.pair with
	  Some(car,cdr,_) ->
	    Some(iter ((rt.label,sttmp)::donelst) car,
		 iter ((rt.label,sttmp)::donelst) cdr)
	| None -> None
      in 
      let v = 
	match rt.vector with
	  Some(v,_) ->
	    Some(iter ((rt.label,sttmp)::donelst) v)
	| None -> None
      in 
      sttmp.Stype.func <- f; 
      sttmp.Stype.pair <- p;
      sttmp.Stype.vector <- v;
      sttmp
  in 
  iter [] rt
	  
(** rtype_scheme  stype_scheme Ѵ , ˴ޤޤ뷿ѿ« *)
let rtypescm_to_stypescm (rts:rtype_scheme) : Stype.stype_scheme = 
  match rts with
    Forall(rlst,_,elst,rt,reg) ->
      Stype.generalize [] (rtype_to_stype rt)
  | Normal(rt) ->
      Stype.generalize [] (rtype_to_stype rt)
	
(** effectǤ uniqueˤ *)
let uniqEffect (eff:effect) :effect =
  uniq eff
    
let sortEffect (e1:effect):effect =
    let effcmp ae1 ae2 = 
      match (ae1,ae2) with
	(Reg(_), Eff(_)) -> -1
      | (Eff(_), Reg(_)) -> 1
      | (Reg(r1), Reg(r2)) -> compare r1 r2
      | (Eff(e1), Eff(e2)) -> compare e1 e2
    in 
    List.sort effcmp (uniqEffect e1)

(** region polymorphic effect  effect ؤѴ *)
let regpolEffToEff (re:regpolEff) : effect =
  List.map (function x -> Reg x) re

      
(** rtypeΥȥåץ٥atomic type֤Ƥ꡼֤ *)
let topLevel (rt:rtype) : region list =
  uniq  ((match rt.num with Some(r) -> [r] | None -> [])
	 @ (match rt.char with Some(r) -> [r] | None -> [])
	 @ (match rt.port with Some(r) -> [r] | None -> [])
	 @ (match rt.string with Some(r) -> [r] | None -> [])
	 @ (match rt.symbol with Some(r) -> [r] | None -> [])
	 @ (match rt.func with Some(_,_,_,r) -> [r] | None -> [])
	 @ (match rt.pair with Some(_,_,r) -> [r] | None -> [])
	 @ (match rt.vector with Some(_,r) -> [r] | None -> []))


(**  *)
let new_Type () : rtype =
  { label = newlabel ();   slabel = Stype.newlabel (); num = None;   bool = false;  
    port=None; char=None; string=None; symbol=None; null=false;
    func =  None;  pair = None; vector = None; }
(** ؿ *)
let new_FuncType ((targ,tail):rtype list * rtype) (ef:latentEffect) (tret:rtype) (r:region) : rtype =
  { label = newlabel ();   slabel = Stype.newlabel ();    num = None;   bool = false;  
    port=None; char=None; string=None; symbol=None; null=false;
    func = Some((targ,tail),ef,tret,r);  pair = None; vector = None; }
(** ͷ *)
let new_NumType (r:region) : rtype =
  {  label = newlabel ();   slabel = Stype.newlabel ();  num = Some(r);  bool = false;
     port=None; char=None; string=None; symbol=None; null=false;
     func = None;   pair = None; vector = None;  }
(** ʸ󷿤 *)
let new_StringType (r:region) : rtype =
  {  label = newlabel ();   slabel = Stype.newlabel ();  num = None;  bool = false;
     port=None; char=None; string=Some(r); symbol=None; null=false;
     func = None;   pair = None; vector = None;  }
(** ͷ *)
let new_BoolType () : rtype =
  {  label = newlabel ();   slabel = Stype.newlabel ();  num = None;  bool = true;
     port=None; char=None; string=None; symbol=None; null=false;
     func = None;   pair = None; vector = None;  }
(** ͷ *)
let new_PortType (r:region) : rtype =
  {  label = newlabel ();   slabel = Stype.newlabel ();  num = None;  bool = false;
     port=Some(r); char=None; string=None; symbol=None; null=false;
     func = None;   pair = None; vector = None;  }
(** ڥ *)
let new_PairType (tcar:rtype) (tcdr:rtype) (r:region)  : rtype =
  {  label = newlabel ();   slabel = Stype.newlabel ();  num = None;  bool = false;
     port=None; char=None; string=None; symbol=None; null=false;
     func = None;   pair = Some(tcar,tcdr,r); vector = None;  }
(** ٥ *)
let new_VectorType (vt:rtype) (r:region)  : rtype =
  {  label = newlabel ();   slabel = Stype.newlabel ();  num = None;  bool = false;
     port=None; char=None; string=None; symbol=None; null=false;
     func = None;   pair = None; vector = Some(vt,r);  }
(** 񤯡  ONˤʤäƤ뷿 *)
let new_AllType r1 r2 r3 r4 r5 r6 ef : rtype =   
  let rec t = {label = newlabel ();   slabel = Stype.newlabel ();  num = Some(r1);  bool = true;
	       port=Some(r2); char=Some(r2); string=Some(r3); symbol=Some(r4); null=true;
	       func = Some(([t],t),ef,t,r5);   pair = Some(t,t,r6);  vector = None; }
  in t
(** 񤯡  ONˤʤäƤ뷿 *)
let new_DatumType r1 : rtype =   
  let rec t = {label = newlabel ();   slabel = Stype.newlabel ();  num = Some(r1);  bool = true;
	       port=Some(r1); char=Some(r1); string=Some(r1); symbol=Some(r1); null=true;
	       func = None;   pair = Some(t,t,r1);  vector = Some(t,r1); }
  in t
(** ꥹȷ *)
let new_ListType (t:rtype) (r:region)  : rtype =
  let rec tmpT = 
    {  label = newlabel ();   slabel = Stype.newlabel ();  num = None;  bool = false;
       port=None; char=None; string=None; symbol=None; null=false;
       func = None;   pair = Some(t,tmpT,r); vector = None;  }
  in tmpT



(**  *)
let rsubst_id = (Rsubst.empty,[])

(** ꡼ѿ *)
let newRegVar = let c = ref 0 in function () -> c := !c + 1; !c(*"r" ^ (string_of_int !c)*)

(** եѿ *)
let newEffVar = let c = ref 0 in function () -> c := !c + 1; "e" ^ (string_of_int !c) 

(** եȺ *)
let newEffect () = []

(** LatentեȺ *)
let newLatentEffect () = (newEffVar () ,[])

(** latentեȤѿФ *)
let getEffVar (e:latentEffect) : effvar =
    match e with
      (ev,eatm) -> ev

(** ꡼ؤ *)
let substToRegion (s:rsubst) (r:region)  : region=
  match s with (sr,se) -> 
    if (Rsubst.mem r sr )
    then Rsubst.find r sr
    else r

(** Latent Effect ʿˤ *)
let flatten_Leff ((ev,efs):latentEffect) : effect= 
  Eff(ev)::efs

(** եȤؤ *)
let substToEffect ((sr,se) as s:rsubst) (e:effect) : effect =
  let substToAtomEff ae = 
    match ae with
      Reg(r) -> [Reg(substToRegion s r)]
    | (Eff(e)) as eatm -> 
	if (List.mem_assoc e se)
	then 
	  begin 
	    flatten_Leff (List.assoc e se)
	  end
	else [eatm]
  in 
  sortEffect (List.flatten (List.map substToAtomEff e))

(** LatentեȤؤ *)
let substToLatentEffect ((rs,es) as s:rsubst) ((ev,effs):latentEffect) 
    : latentEffect =
  if (List.mem_assoc ev es) 
  then 
    let (newev,neweffs) = List.assoc ev es in
    (newev, uniq (neweffs @ (substToEffect s effs)))
  else (ev, substToEffect s effs)
  
(** rsubst ι rs1 ŬѤƤ rs2 *)
let rsubstCombine (rs2:rsubst) (rs1:rsubst) : rsubst =
  match rs1 with
    (sr1,se1) -> 
      let (newsr1,newse1) =
	(Rsubst.map (function r -> substToRegion rs2 r) sr1,
	 List.map (function (e1,e2) -> (e1,substToLatentEffect rs2 e2)) se1)
      in (rsubst_append (fst rs2) newsr1, (snd rs2)@newse1)


(* Ϥޤɤ뤫̯ *)
(*let rec unifyElseRegion (rs:rtype_scheme) (rt:rtype) : rsubst = 
  let matching_num id r rt = 
    if(rt.rid = id)
    then 
      unifyRegion 


  match rs with
    Forall(regs,regpoleff,effs,rtsc,reg) ->
      
      let rec iter rs rt = 
      begin
	let s1 = 
	  begin 
	    match (rtsc.num,rt.num) with
	      (None,Some(r)) ->
		matching_num rt.rid r rt
	    | _ -> ([],[])
	  end
	in 
	let s2 = 
	  begin 
	    match (rtsc.pair, substToType s1 rt.pair) with
	      (None,Some(car,cdr,r)) ->
		rsubstCombine (matching_pair rt.rid r) s1
	    | (Some(cars,cdrs,_),Some(car,cdr,_)) ->
		let tmps = iter cars car in
		rsubstCombine (rusbstCombine (iter cdrs (substToType s2 cdr)) tmps) s1
	    | _ -> s1
	  end
	in s2
      end
      in iter rtsc rt
  | _ -> ([],[])
  *)     
      

(** rtype ؤ *)
let substToType s (rt:rtype) = 
  let rec iter (donelst:(id * rtype) list) (rt:rtype) : rtype =
    if (List.mem_assoc rt.label donelst)
    then List.assoc rt.label donelst
    else
      let newt =
	{ label = rt.label;
	  slabel   = rt.slabel;
	  num = begin match rt.num with None -> None | Some(r) -> Some(substToRegion s r) end;
	  bool = rt.bool;
	  char = begin match rt.char with None -> None | Some(r) -> Some(substToRegion s r) end;
	  port = begin match rt.port with None -> None | Some(r) -> Some(substToRegion s r) end;
	  string = begin match rt.string with None -> None | Some(r) -> Some(substToRegion s r) end;
	  symbol = begin match rt.symbol with None -> None | Some(r) -> Some(substToRegion s r) end;
	  null = rt.null;
	  func = None;
	  pair = None;
	  vector = None; 
	}
      in
      newt.func <-
	begin
	  match rt.func with
	    None -> None
	  | Some((args,tail),eff,ret,reg) -> 
	      let newargs = List.map (iter ((rt.label,newt)::donelst)) args in
	      let newtail = iter ((rt.label,newt)::donelst) tail in
	      let newret  = iter ((rt.label,newt)::donelst) ret in
	      Some((newargs,newtail),
		   substToLatentEffect s eff,
		   newret,
		   substToRegion s reg)
	end;
      newt.pair <- 
	begin
	  match rt.pair with
	    None -> None
	  | Some(car,cdr,reg) -> 
	      let newcar = iter ((rt.label,newt)::donelst) car in
	      let newcdr = iter ((rt.label,newt)::donelst) cdr in
	      Some(newcar,  newcdr,
		   substToRegion s reg)
	end;
      newt.vector <- 
	begin
	  match rt.vector with
	    None -> None
	  | Some(v,reg) -> 
	      let newv = iter ((rt.label,newt)::donelst) v in
	      Some(newv,
		   substToRegion s reg)
	end;
      newt
  in 
  iter [] rt
    
(** ꡼ unify *)
let unifyRegion (a:region) (b:region) : rsubst =
  if(a = b) 
  then (Rsubst.empty,[])
  else (Rsubst.add a b Rsubst.empty , [] )


(** ȥåץ٥Υ꡼ unify  *)
let topLevel_unify (rt:rtype) : rsubst =
  let top = topLevel rt in
  let rsub = 
    match top with
      hd::tl -> 
	List.fold_right (fun x t -> Rsubst.add x hd t) tl Rsubst.empty
    | [] ->
	Rsubst.empty
  in (rsub,[])



(** եȤ unify *)
let unifyLatentEffect ((v1,e1):latentEffect) ((v2,e2):latentEffect) 
    : rsubst =
  let newLf = (v1, sortEffect (e1@e2)) in
  (Rsubst.empty,[(v1,newLf);(v2,newLf)])
  

(** stype 顢ѿղä rtype   *)
let rec addRegEff (s:Stype.stype) : rtype =
  let rec iter (donelst:(id * rtype) list) (s:Stype.stype) : rtype =
    if(List.mem_assoc s.Stype.label donelst)
    then 
      List.assoc s.Stype.label donelst
    else 
      let newr = 
	{ label = newlabel ();
	  slabel = s.Stype.label; 
	  num = if s.Stype.num then Some(newRegVar ()) else None;
	  bool = s.Stype.bool;
	  char = if s.Stype.char then Some(newRegVar ()) else None;
	  port = if s.Stype.port then Some(newRegVar ()) else None;
	  string = if s.Stype.string then Some(newRegVar ()) else None;
	  symbol = if s.Stype.symbol then Some(newRegVar ()) else None;
	  null = s.Stype.null;
	  func = None;
	  pair = None;
	  vector = None;
	}
      in 
      newr.func <- 
	begin 
	  match s.Stype.func with
	    Some((args,tail),b) -> 
	      let argsR = List.map (iter ((s.Stype.label,newr)::donelst)) args in
	      let tailR = iter ((s.Stype.label,newr)::donelst) tail in
	      let retR = iter ((s.Stype.label,newr)::donelst) b in
	      Some((argsR,tailR),newLatentEffect (),retR,newRegVar ())
	  | None -> None
	end;
      newr.pair <-
	begin 
	  match s.Stype.pair with
	    Some(car,cdr) -> 
	      let carR = iter ((s.Stype.label,newr)::donelst) car in
	      let cdrR = iter ((s.Stype.label,newr)::donelst) cdr in
	      Some(carR,cdrR,newRegVar ())
	  | None -> None
	end;
      newr.vector <-
	begin 
	  match s.Stype.vector with
	    Some(v) -> 
	      let vR = iter ((s.Stype.label,newr)::donelst) v in
	      Some(vR,newRegVar ())
	  | None -> None
	end;
      newr
  in iter [] s

let strictAddRegEff (s:Stype.stype) : rtype =
  
  let rec iter (donelst:(id * rtype) list) (s:Stype.stype) : ((id * rtype) list * rtype) =
    if(List.mem_assoc s.Stype.label donelst)
    then 
      (donelst, List.assoc s.Stype.label donelst)
    else 
      let newr = 
	{ label = newlabel ();
	  slabel = s.Stype.label; 
 	  num = if s.Stype.num then Some(newRegVar ()) else None;
	  bool = s.Stype.bool;
 	  char = if s.Stype.char then Some(newRegVar ()) else None;
 	  port = if s.Stype.port then Some(newRegVar ()) else None;
 	  string = if s.Stype.string then Some(newRegVar ()) else None;
 	  symbol = if s.Stype.symbol then Some(newRegVar ()) else None;
 	  null = s.Stype.null;
 	  func = None;
 	  pair = None;
 	  vector = None;
 	}
      in 
      let newdonelst = (s.Stype.label,newr)::donelst in
      let (fund,func) =
 	begin 
 	  match s.Stype.func with
	     Some((args,tail),b) -> 
 	       (* let argsR = List.map (iter ((s.Stype.label,newr)::donelst)) args in *)
	       let (argd,argsR) =
		 List.fold_right 
		   (fun rt (donlst,args) -> let (newdon,newrt) = iter donlst rt in (newdon,newrt::args))
		   args (newdonelst,[]) in
	       let (td,tailR) = iter argd tail in
	       let (rd,retR) = iter td b in
	       (rd,Some((argsR,tailR),newLatentEffect (),retR,newRegVar ()))
	  | None -> (newdonelst,None)
	end
      in 
      newr.func <- func; 
      let (paird,pair) = 
	begin 
	  match s.Stype.pair with
	    Some(car,cdr) -> 
	      let (card,carR) = iter fund car in
	      let (paird,cdrR) = iter card cdr in
	      (paird,Some(carR,cdrR,newRegVar ()))
	  | None -> (fund,None)
	end
      in 
      newr.pair <- pair;
      let (vecd,vec) = 
	begin 
	  match s.Stype.vector with
	    Some(v) -> 
	      let (vd,vR) = iter paird v in
	      (vd,Some(vR,newRegVar ()))
	  | None -> (paird,None)
	end
      in 
      newr.vector <- vec;
      (vecd,newr)
  in 
  let (_,rt) = iter [] s in
  rt
    
(**
 * ꡼դ unify 
 * Ūʷι¤ϰפƤʤȤʤ
 * unify Τ stype Ǵ unify ƤʪƱΤʤΤǡ
 * IDƱǤäƤ unifyʤƤϤʤʤ
 *)
let unifyRtype (a:rtype) (b:rtype) 
    : rsubst = 
(*  print_endline "unify";
  print_endline (string_of_rtype a);
  print_endline (string_of_rtype b);
   print_endline "";*)
  let rec iter  (donelst:(id * id) list) (a:rtype) (b:rtype) =
    if ((List.mem (a.label,b.label) donelst)||
    (List.mem (b.label,a.label) donelst))
    then (Rsubst.empty,[]) (* unify Ѥߤʤ鲿֤ʤ *)
    else
      let tmp1 = 
	match (a.num, b.num) with
	  (Some ra,Some rb) -> unifyRegion ra rb
	| (None,None) -> (Rsubst.empty,[])
	| (_,_) -> (Rsubst.empty,[])
      in 
      let tmp2 = 
	match (a.char, b.char) with
	  (Some ra,Some rb) -> rsubstCombine (unifyRegion (substToRegion tmp1 ra) (substToRegion tmp1 rb)) tmp1
	| (None,None) -> tmp1
	| (_,_) -> tmp1
      in 
      let tmp2 = 
	match (a.port, b.port) with
	  (Some ra,Some rb) -> rsubstCombine (unifyRegion (substToRegion tmp1 ra) (substToRegion tmp1 rb)) tmp2
	| (None,None) -> tmp2
	| (_,_) -> tmp2
      in 
      let tmp3 = 
	match (a.string, b.string) with
	  (Some ra,Some rb) -> rsubstCombine (unifyRegion (substToRegion tmp1 ra) (substToRegion tmp1 rb)) tmp2
	| (None,None) -> tmp2
	| (_,_) -> tmp2
      in 
      let s1 = 
	match (a.symbol, b.symbol) with
	  (Some ra,Some rb) -> rsubstCombine (unifyRegion (substToRegion tmp1 ra) (substToRegion tmp1 rb)) tmp3
	| (None,None) -> tmp3
	| (_,_) -> tmp3
      in 
      let s2 =
	match (a.func, b.func) with
	  (Some((arg1,tail1),ef1,ret1,reg1),Some((arg2,tail2),ef2,ret2,reg2)) ->
	    let tmpS1 = 
	      rsubstCombine 
		(unifyRegion (substToRegion s1 reg1) (substToRegion s1 reg2)) s1 in
	    let tmpS2 = 
	      Mylist.fold_left2_cut  
		(fun s ta tb -> 
		  rsubstCombine
		    (iter ((a.label,b.label)::donelst) 
		       (substToType s ta) (substToType s tb)) s)
		tmpS1 arg1 arg2 
	    in 
	    let tmpS3 = 
	      rsubstCombine
		(iter ((a.label,b.label)::donelst) 
		   (substToType tmpS2 ret1) (substToType tmpS2 ret2) )
		tmpS2 in
	    let tmpS4 = 
	      rsubstCombine
		(unifyLatentEffect (substToLatentEffect tmpS3 ef1) 
		   (substToLatentEffect tmpS3 ef2))
		tmpS3 in
	    let tmpS5 = 
	      rsubstCombine
		(iter ((a.label,b.label)::donelst) 
		   (substToType tmpS2 tail1) (substToType tmpS2 tail2)) 
		tmpS4
	    in
	    tmpS5
	| (None,None) -> s1
	| (_,_) -> s1
      in 
      let s3 = 
	match (a.pair, b.pair) with
	  (Some(car1,cdr1,reg1),Some(car2,cdr2,reg2)) ->
	    let tmpS1 = 
	      rsubstCombine
		(iter 
		   ((a.label,b.label)::donelst) 
		   (substToType s2 car1) (substToType s2 car2) )
		s2 in
	    let tmpS2 = 
	      rsubstCombine
		(iter ((a.label,b.label)::donelst)
		   (substToType tmpS1 cdr1) (substToType tmpS1 cdr2) 
		)
		tmpS1 in
	    let tmpS3 = 
	      rsubstCombine
		(unifyRegion (substToRegion tmpS2 reg1) (substToRegion tmpS2 reg2))
		tmpS2 in
	    tmpS3
	| (None,None) -> s2
	| (_,_) -> s2
      in
      let s4 = 
	match (a.vector, b.vector) with
	  (Some(v1,reg1),Some(v2,reg2)) ->
	    let tmpS1 = 
	      rsubstCombine
		(iter 
		   ((a.label,b.label)::donelst) 
		   (substToType s3 v1) (substToType s3 v2) )
		s3 in
	    let tmpS2 = 
	      rsubstCombine
		(unifyRegion (substToRegion tmpS1 reg1) (substToRegion tmpS1 reg2))
		tmpS1 
	    in
	    tmpS2
	| (None,None) -> s3
	| (_,_) -> s3
      in s4
  in iter [] a b

(** latent եȤμͳʥ꡼ѿȥեѿ *)
let fvToEffect ((ev,ate):latentEffect) : (region list * effvar list) =
  (* ([],[ev]) *)
  (Mylist.append2 (divide_effect ate) ([],[ev]))


(** ͳ꡼&եѿ *)	   
let fv (rt:rtype) : (region list * effvar list) =
  let rec iter (donelst:id list) (rt:rtype) :(region list * effvar list) = 
    if(List.mem rt.label donelst) then ([],[])
    else
      List.fold_right 
	append2
	[(match rt.num with None -> ([],[]) | Some(r) -> ([r],[]));
	 (match rt.char with None -> ([],[]) | Some(r) -> ([r],[]));
	 (match rt.port with None -> ([],[]) | Some(r) -> ([r],[]));
	 (match rt.string with None -> ([],[]) | Some(r) -> ([r],[]));
	 (match rt.symbol with None -> ([],[]) | Some(r) -> ([r],[]));
	 (match rt.func with
	   Some((args,tail),ef,ret,reg) -> 
	     let (rar,rae) = 
	       List.fold_right append2 
		 (List.map (iter (rt.label::donelst)) args) ([],[]) in
	     let (rcr,rce) = iter (rt.label::donelst) tail in
	     let (rbr,rbe) = iter (rt.label::donelst) ret in
	     let (er,ee)   = fvToEffect ef in
	     (reg::rar@rbr@er@rcr,rae@rbe@ee@rce)
	 | None -> ([],[]));
	 (match rt.vector with
	   Some(v,r) -> 
	     let (rar,rae) = iter (rt.label::donelst) v in 
	     (r::rar, rae)
	 | None -> ([],[]));
	 (match rt.pair with
	   Some(ra,rb,r) -> 
	     let (rar,rae) = iter (rt.label::donelst) ra in 
	     let (rbr,rbe) = iter (rt.label::donelst) rb in
	     (r::rar@rbr, rae@rbe)
	 | None -> ([],[]))] 
	([],[])
  in 
  let (a,b) = iter [] rt in (uniq a,uniq b)
	
(** μͳѿ *)
let fv_of_Scheme (rt:rtype_scheme) : (region list * effvar list) =
  match rt with
    Forall(rlst,eff,elst,rty,r) ->
      let (fr,fe) = fv rty in
      (r::(subtract_list fr rlst),
       subtract_list fe elst)
  | Normal(rty) ->
      fv rty 

(** Ķμͳѿ *)
let fv_of_Env (rte:rtype_env) : (region list * effvar list) =
  let (rs,es) = 
    List.fold_right append2 
      (List.map (function (_,s) -> fv_of_Scheme s) rte) ([],[]) in
  (uniq rs, uniq es)
      

(** rtypegeneralize *)
let rgeneralize (rte:rtype_env) (rt:rtype) (polreg:region): rtype_scheme =
  let (refv,eefv) = fv_of_Env rte in
  let (rfv,efv) = fv rt in
  let tops = topLevel rt in
  Forall(subtract_list rfv refv, tops,
	 subtract_list efv eefv, rt, polreg)


(** ؤ *)
let substToRScheme ((subr,sube) as sub:rsubst) (rscm:rtype_scheme) 
    :rtype_scheme =
  match rscm with
    Forall(rlst,reff,elst,rt,reg) ->
      let subrd = 
	Rsubst.fold (fun key v t -> if(List.mem key rlst) then t else Rsubst.add key v t) subr Rsubst.empty in
	  (* List.filter 
	  (function (r,_) -> not (List.mem r rlst)) subr in *)
      let subed = List.filter 
	  (function (e,_) -> not (List.mem e elst)) sube in
      Forall(rlst,reff,elst,
	     substToType (subrd,subed) rt,
	     substToRegion (subrd,subed) reg)
  | Normal(tr) -> Normal(substToType sub tr)
	
(** Ķؤ *)
let substToRenv (sub:rsubst) (re:rtype_env) : rtype_env = 
  List.map (function (x,rscm) -> (x,substToRScheme sub rscm)) re




    
(** effectʸɽ *)    
let string_of_effect (eff:effect) =
  "{" ^ 
  (List.fold_right (^)
    (List.map (function Reg(r) -> (string_of_reg r) | Eff(e) -> e) eff) 
    "") 
  ^ "}"

(** rtype_scheme ʸɽ *)
let string_of_rtype_scheme rs =  
  match rs with
    Forall(rlst,rpeff,eflst,rt,reg) ->
      "\\" ^ (List.fold_right (^) (List.map string_of_reg rlst) "") ^ "^{" 
      ^ (List.fold_right (^) (List.map string_of_reg rpeff) "") ^ "}\\" 
      ^ (List.fold_right (^) eflst "" ) ^ "." ^ (string_of_rtype rt)
      ^ "," ^ (string_of_reg reg )
  | Normal(rt) ->
      (string_of_rtype rt)

(** effect ˴ޤޤ ꡼ѿФ *)
let regs_in_effect (ef:effect) : region list = 
  List.fold_right (@) 
    (List.map (function Reg(r) -> [r] | Eff(e) -> []) ef) []
    


(** effect Ƚꤹؿ *)
let isEquiveEffect (e1:effect) (e2:effect) : bool =
  if(List.length e1 != List.length e2) then false
  else 
    let effcmp ae1 ae2 = 
      match (ae1,ae2) with
	(Reg(_), Eff(_)) -> -1
      | (Eff(_), Reg(_)) -> 1
      | (Reg(r1), Reg(r2)) -> compare r1 r2
      | (Eff(e1), Eff(e2)) -> compare e1 e2
    in 
    (List.fold_right (&&) 
       (List.map (function (x,y) -> (effcmp x y) = 0)
	  (List.combine (List.sort effcmp e1) (List.sort effcmp e2))) true)

(**  latent effect Ƚꤹؿ *)
let isEquivLtntEffect ((ev1,ef1):latentEffect) ((ev2,ef2):latentEffect) 
    : bool =
  (ev1 = ev2)&&(isEquiveEffect ef1 ef2)

(** scheme Ƚꤹؿ *)
let isEquivRtype (r1:rtype) (r2:rtype) : bool =
  let rec iter donelst  (r1:rtype) (r2:rtype) : bool =
    if(r1.label <> r2.label)
    then false
    else 
      if List.mem r1.label donelst 
      then true
      else 
	List.fold_right (&&)
	  [begin
	    match (r1.num,r2.num) with
	      (Some(a),Some(b)) -> a = b
	    | (None,None) -> true
	    | (_,_) -> false
	  end;
	   r1.bool = r2.bool;
	   begin
	     match (r1.char,r2.char) with
	      (Some(a),Some(b)) -> a = b
	    | (None,None) -> true
	    | (_,_) -> false
	   end;
	   begin
	     match (r1.port,r2.port) with
	      (Some(a),Some(b)) -> a = b
	    | (None,None) -> true
	    | (_,_) -> false
	   end;
	   begin
	    match (r1.string,r2.string) with
	      (Some(a),Some(b)) -> a = b
	    | (None,None) -> true
	    | (_,_) -> false
	  end;
	   begin
	    match (r1.symbol,r2.symbol) with
	      (Some(a),Some(b)) -> a = b
	    | (None,None) -> true
	    | (_,_) -> false
	  end;
	   r1.null = r2.null;
	   begin
	     match (r1.func,r2.func) with
	       (Some((ra1,rt1),le1,rr1,reg1),Some((ra2,rt2),le2,rr2,reg2)) ->
		 (List.fold_right (&&) 
		    (List.map2 (iter (r1.label::donelst)) ra1 ra2) true)
		   && (iter (r1.label::donelst) rt1 rt2)
		   && (isEquivLtntEffect le1 le2)
		   && (iter (r1.label::donelst) rr1 rr2)
		   && (reg1 = reg2) 
	     | (None,None) -> true
	     | (_,_) -> false
	   end;
	   begin
	     match (r1.vector,r2.vector) with
	       (Some(v1,reg1),Some(v2,reg2)) ->
		 (iter (r1.label::donelst) v1 v2)
		   && (reg1 = reg2)
	     | (None,None) -> true
	     | (_,_) -> false
	   end;
	   begin
	     match (r1.pair,r2.pair) with
	       (Some(car1,cdr1,reg1),Some(car2,cdr2,reg2)) ->
		 (iter (r1.label::donelst) car1 car2)
		   && (iter (r1.label::donelst) cdr1 cdr2)
		   && (reg1 = reg2)
	     | (None,None) -> true
	     | (_,_) -> false
	   end;]
	  true
  in iter [] r1 r2
    
(** scheme Ƚꤹؿ *)
let isEquivRtypeScm (r1:rtype_scheme) (r2:rtype_scheme) : bool =
  match (r1,r2) with
    (Normal(rt1),Normal(rt2)) ->
      isEquivRtype rt1 rt2
  | (Forall(regs1, poleff1, effs1, rt1, reg1),
     Forall(regs2, poleff2, effs2, rt2, reg2)) ->
       if((List.length regs1 != List.length regs2)
	|| (List.length effs1 != List.length effs2))
       then false
       else 
	 let tmpS = 
	   (List.fold_right (fun (x,y) t -> Rsubst.add x y t) (List.combine regs1 regs2) Rsubst.empty,
	    List.combine effs1 (List.map (function x -> (x,[])) effs2))
	 in 
	 isEquivRtype (substToType tmpS rt1) rt2
  | (_,_) -> false



(* ˤǤΤɤϤʤ *)
let instantiate (tmpS:rsubst) (polt:rtype) (st:Stype.stype) : rtype = 
  let optionRt = strictAddRegEff st in
  let rec iter (donelst:(id * rtype) list) (polt:rtype) (opt:rtype)  = 
    if (List.mem_assoc polt.label donelst)
    then List.assoc polt.label donelst
    else 
      let newType = 
	{label = newlabel ();
	 slabel = opt.slabel;
	 num =  begin  match (polt.num,opt.num) with
	   (Some(r),_)  -> Some(substToRegion tmpS r)
	 | (_ ,opn) -> opn end;
	 char = begin  match (polt.char,opt.char) with
	   (Some(r),_)  -> Some(substToRegion tmpS r)
	 | (_ ,opn) -> opn end;
	 port = begin  match (polt.port,opt.port) with
	   (Some(r),_)  -> Some(substToRegion tmpS r)
	 | (_ ,opn) -> opn end;
	 symbol = begin  match (polt.symbol,opt.symbol) with
	   (Some(r),_)  -> Some(substToRegion tmpS r)
	 | (_ ,opn) -> opn end;
	 string = begin  match (polt.string,opt.string) with
	   (Some(r),_)  -> Some(substToRegion tmpS r)
	 | (_ ,opn) -> opn end;
	 bool = polt.bool || opt.bool;
	 null = polt.null || opt.null;
	 pair = None;
	 func = None;
	 vector = None;
     }
      in
      let newdnlst = (polt.label,newType)::donelst in
      newType.pair <-
	begin 
	  match (polt.pair, opt.pair) with
	    (Some(car,cdr,r),Some(scar,scdr,sr)) ->
	      Some(iter newdnlst car scar,iter newdnlst cdr scdr,substToRegion tmpS r)
	  | (_,p) -> p
	end;
      newType.vector <-
	begin 
	  match (polt.vector, opt.vector) with
	    (Some(v,r),Some(sv,sr)) ->
	      Some(iter newdnlst v sv,substToRegion tmpS r)
	  | (_,p) -> p
	end;
      newType.func <-
	begin 
	  match (polt.func,opt.func) with
	    (Some((args,el),eff,ret,r),Some((sargs,sel),seff,sret,sr)) ->
	      Some((List.map (fun (x,y) -> iter newdnlst x y) 
		      (Mylist.cutoff_combine args sargs), (* List.combine ⡩*)
		    iter newdnlst el sel),
		   substToLatentEffect tmpS eff,
		   iter newdnlst ret sret,
		   substToRegion tmpS r)
	  | (_,f) -> f
	end;
      newType
  in
  iter [] polt optionRt


let subst_filter ((regs,effs):(region list * effvar list)) ((regsub,effsub):rsubst) : rsubst =
  (List.fold_right (fun key t -> Rsubst.add key (substToRegion (regsub,effsub) key) t) regs Rsubst.empty,
   List.fold_right 
     (fun key t -> 
       if(List.mem_assoc key effsub)
       then 
	 (key, List.assoc key effsub)::t
       else
	 t) effs [])

      
      
      
