(* ꡼ȡ꡼ĤȡեȤȡ*)
(* $Id: rtype.mli,v 1.11 2003/10/11 15:48:50 ganat Exp $ *)

(* ---------------------- *)


(** Id *)
type id = string

(** ꡼ *)
type region

val string_of_reg : region -> string
val global_reg : region

(** եѿ *)
type effvar = id

(** ȥߥåե *)
type atmEff = 
    Reg of region 
  | Eff of effvar 

(** ե *)
type effect = atmEff list

(** latentե *)
type latentEffect = effvar * effect


(** ꡼Ĥ  *)
type rtype = 
    { label:id; 
      slabel:  id;
      num:region option; 
      bool:bool; 
      char:region option;
      port:region option;
      string:region option;
      symbol:region option;
      null: bool;
      mutable func:((rtype list * rtype) * latentEffect * rtype * region) option;
      mutable pair:(rtype * rtype * region) option;
      mutable vector:(rtype * region) option;
    }
(* ꡼ *)
type substRegion  (*= (region * region) list  *)

val list_map_to_rsubst :  (region * region) list -> substRegion 

(* եѿ *)
type substEffect = (effvar * latentEffect) list

(* ꡼󤬴Ϣ *)
type rsubst = substRegion * substEffect

(* ꡼¿ؿ˥꡼ȤŬѤΥե *)
type regpolEff = region list

(*  *)
type rtype_scheme = 
    (* (rlst ^ reff eff . rt , reg) *)
    Forall of region list * regpolEff 
	* effvar list *  rtype * region
  | Normal of rtype 

(* Ķ *)
type rtype_env = (string * rtype_scheme) list

(* --------- ˻Ȥؿ --------- *)


val rtype_car_of_pair : rtype -> rtype
(** rtype_scheme  stype_scheme Ѵ , ˴ޤޤ뷿ѿ« *)
val rtypescm_to_stypescm : rtype_scheme -> Stype.stype_scheme

val sortEffect : effect -> effect

(*  *)
val rsubst_id : rsubst

(* region polymorphic effect  effect ؤѴ *)
val regpolEffToEff : regpolEff -> effect

(* ꡼ѿ *)
val newRegVar : unit -> region

(* եȺ *)
val newEffect : unit -> effect

(* LatentեȺ *)
val newLatentEffect : unit -> latentEffect

(* եѿ *)
val newEffVar : unit -> effvar 

(* եȤѿФ *)
val getEffVar : latentEffect -> effvar 

(* ꡼ؤ *)
val substToRegion : rsubst -> region -> region

(* latentեȤؤ *)
val substToEffect : rsubst -> effect -> effect

(* եȤؤ *)
val substToLatentEffect : rsubst -> latentEffect -> latentEffect

(* rsubst ι rs1 ŬѤƤ rs2 *)
val rsubstCombine : rsubst -> rsubst -> rsubst 

(* rtype ؤ *)
val substToType : rsubst -> rtype -> rtype  

(* ꡼ unify *)
val unifyRegion : region -> region -> rsubst 

(** ȥåץ٥Υ꡼ unify  *)
val topLevel_unify : rtype -> rsubst

(* եȤ unify *)
val unifyLatentEffect : latentEffect -> latentEffect -> rsubst 

(* stype 顢ѿղä rtype   *)
val addRegEff : Stype.stype -> rtype 

(*꡼դ unify *)
val unifyRtype : rtype -> rtype -> rsubst
	    
(* generalize *)
val rgeneralize : rtype_env -> rtype -> region -> rtype_scheme

(* ؤ *)
val substToRScheme : rsubst -> rtype_scheme -> rtype_scheme

(* Ķؤ *)
val substToRenv : rsubst -> rtype_env -> rtype_env



(* Latent Effect ʿˤ *)
val flatten_Leff : latentEffect -> effect


(* effectǤ uniqueˤ *)
val uniqEffect : effect -> effect 


(* rtypeʸɽ *)
val string_of_rtype : rtype -> string

(* effectʸɽ *)
val string_of_effect : effect -> string

(* rtype_scheme ʸɽ *)
val string_of_rtype_scheme : rtype_scheme -> string

(* Ķμͳѿ *)
val fv_of_Env : rtype_env -> (region list * effvar list)

(* μͳѿ *)
val fv  : rtype -> (region list * effvar list)
(* μͳѿ *)
val fv_of_Scheme  : rtype_scheme -> (region list * effvar list)

(* effect ˴ޤޤ ꡼ѿФ *)
val regs_in_effect : effect -> region list

(* atomic effect ʸɽ *)
val string_of_atmEff : atmEff -> string

(* latent effect ʸɽ *)
val string_of_ltntEff  : latentEffect -> string
	
(* rsubst ʸɽ *)
val string_of_rsubst : rsubst -> string 

(* effect Ƚꤹؿ *)
val isEquiveEffect : effect -> effect -> bool

(*  latent effect Ƚꤹؿ *)
val isEquivLtntEffect : latentEffect -> latentEffect -> bool
   
(* scheme Ƚꤹؿ *)
val isEquivRtype : rtype -> rtype -> bool

(* scheme Ƚꤹؿ *)
val isEquivRtypeScm : rtype_scheme -> rtype_scheme -> bool


(*  *)
val new_Type : unit -> rtype
(* ؿ *)
val new_FuncType : (rtype list * rtype) -> latentEffect -> rtype -> region -> rtype
(* ͷ *)
val new_NumType : region -> rtype
(* ʸ󷿤 *)
val new_StringType : region -> rtype
(* ͷ *)
val new_BoolType : unit -> rtype
(* ݡȷ *)
val new_PortType : region -> rtype
(* ڥ *)
val new_PairType : rtype -> rtype -> region -> rtype
(* ٥ *)
val new_VectorType : rtype -> region -> rtype
(*  *)
val new_AllType :  region -> region -> region -> region -> region -> region -> latentEffect -> rtype
(* ꥹȷ *)
val new_ListType : rtype -> region -> rtype
(* datum *)
val new_DatumType : region -> rtype


(** rtypeΥȥåץ٥atomic type֤Ƥ꡼֤ *)
val topLevel : rtype -> region list


val instantiate : rsubst -> rtype -> Stype.stype -> rtype

val subst_filter : (region list * effvar list) -> rsubst -> rsubst

val divide_effect : effect -> (region list * effvar list)
