(* $B7?$N%i%Y%k(B *)
type id = string
(* Scheme $B$N7?(B *)
type stype = 
    { label:id; 
      num:bool; 
      bool:bool; 
      char:bool;
      port:bool;
      string:bool;
      symbol:bool;
      null:bool;
      mutable func:((stype list * stype) * stype) option; (* tail $BItJ,$N7?$O>o$K%j%9%H(B *)
      mutable pair:(stype * stype) option;
      mutable vector:stype option
    }

(* $BBeF~(B *)
type subst = (id * stype) list
(* $B7?%9%-!<%`(B *)
type stype_scheme 
(* $B7?4D6-(B *)
type type_env = (string * stype_scheme) list

(* $B?7$7$$%i%Y%k(B *)
val newlabel : unit -> id

(* stype $B$NI=<((B *)
val string_of_stype : stype -> string
(* $B?7$7$$7?(B *)
val unknown_type : unit -> stype
val num_type : unit -> stype 
val bool_type : unit -> stype
val null_type : unit -> stype
val port_type : unit -> stype
val char_type : unit -> stype
val string_type : unit -> stype
val symbol_type : unit -> stype
val func_type : (stype list * stype) -> stype -> stype
val pair_type : stype -> stype -> stype
val list_type : stype -> stype
(* substitute *)    
val substitute : subst -> stype -> stype
val substitute_scheme : subst -> 
  stype_scheme -> stype_scheme
val substitute_tenv : subst -> type_env -> type_env
(* $BBeF~$N9g@.(B  s1 $B$rBeF~$7$F$+$i(B s2 $B$rBeF~$9$k$N$HF1$8$K$J$k(B *)
val subst_combine : subst -> subst -> subst
(* $BBeF~$NI=<((B *)
val print_subst : (id * stype) -> unit
val print_substs : subst -> unit
(* unification *)    
val unify : stype -> stype -> subst
(* generalize *)
val generalize  : type_env -> stype -> stype_scheme
(* instantiate *)
val instantiate : stype_scheme -> stype
(* $B$=$N$^$^7?%9%-!<%`$K$9$k!#(B*)
val stype2scheme : stype -> stype_scheme
(* $B7?%9%-!<%`$NJ8;zNsI=<(!#(B*)
val string_of_stype_scheme : stype_scheme ->  string


val fv_stype : stype -> id list
val fv_scheme : stype_scheme -> id list
val fv_type_env : type_env  -> id list
