open Syntax
open Stype

(* $B7?$D$-%7%s%?%C%/%9(B *) 
type texp =
    TVal of svalue * stype
  | TVar of string *stype
  | TLambda of (lbind list * lbind option) * texp * stype
  | TApp of texp * texp list * stype
  | TLet of tbind list * texp * stype
  | TLetrec of tbind list * texp * stype
  | TIf  of texp * texp * texp * stype 
(*  | TPair of texp * texp * stype *)
and tbind = { sid:string ; st:stype_scheme ;sbody:texp }
and lbind = { lid:string ; lt:stype_scheme}

val getType : texp -> stype
val substitute_texp : subst -> texp -> texp
val stype_infer : type_env -> exp ->  (subst * texp) 

val string_of_texp : texp -> string

val isValue : texp -> bool

val print_texp : texp -> unit

val size : texp -> int
